import { Event, CustomConsumerMessage } from '../interfaces';
import { KafkaMessage } from 'kafkajs';
export declare abstract class Listener<T extends Event> {
    abstract topic: T['topic'];
    abstract fromBeginning: boolean | undefined;
    abstract subscribe(): Promise<void>;
    abstract onMessages(message: CustomConsumerMessage<T>, heartbeat?: () => Promise<void>): Promise<void>;
    private parseMessage;
    private convert;
    listen(message: KafkaMessage, heartbeat?: () => Promise<void>): Promise<void>;
}
