import { CustomProducerMessage, Event } from '../interfaces';
import { CompressionTypes, RecordMetadata, IHeaders } from 'kafkajs';
export declare abstract class Publisher<T extends Event> {
    abstract topic: T['topic'];
    abstract acks?: number;
    abstract timeout?: number;
    abstract compression?: CompressionTypes;
    abstract get messages(): CustomProducerMessage<T>[];
    abstract pushMessage(value: T['data'], key?: string | null, partition?: number, headers?: IHeaders, timestamp?: string): void;
    publish(): Promise<RecordMetadata[]>;
}
