"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserCreatedPublisher = void 0;
var errors_1 = require("../../errors");
var interfaces_1 = require("../../interfaces");
var base_publisher_1 = require("../base-publisher");
var UserCreatedPublisher = /** @class */ (function (_super) {
    __extends(UserCreatedPublisher, _super);
    function UserCreatedPublisher() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.acks = undefined;
        _this.timeout = undefined;
        _this.topic = interfaces_1.Topics.USER_CREATED;
        _this.compression = undefined;
        _this._messages = [];
        return _this;
    }
    Object.defineProperty(UserCreatedPublisher.prototype, "messages", {
        get: function () {
            if (!this._messages)
                throw new errors_1.GenericValidationError({ error: new Error('_messages should be available before publishing a topic'), errorCode: 500 });
            return this._messages;
        },
        enumerable: false,
        configurable: true
    });
    ;
    UserCreatedPublisher.prototype.pushMessage = function (value, key, partition, headers, timestamp) {
        this._messages.push({ value: value, key: key, partition: partition, headers: headers, timestamp: timestamp });
    };
    ;
    return UserCreatedPublisher;
}(base_publisher_1.Publisher));
exports.UserCreatedPublisher = UserCreatedPublisher;
;
