import { Consumer, ConsumerConfig, ConsumerRunConfig, Producer, ProducerConfig } from 'kafkajs';
import { Listener } from '../events';
export declare abstract class EventBus {
    abstract get producer(): Producer;
    abstract get consumer(): Consumer;
    abstract get isProducerReq(): boolean;
    abstract get isConsumerReq(): boolean;
    abstract set clientId(clientId: string);
    abstract set brokers(brokers: string[]);
    abstract set producerConfig(producerConfig: ProducerConfig);
    abstract set consumerConfig(consumerConfig: ConsumerConfig);
    abstract set consumerRunConfig(consumerRunConfig: ConsumerRunConfig);
    abstract set listeners(listeners: Listener<any>[]);
    abstract setup(isProducerReq: boolean, isConsumerReq: boolean): void;
    abstract init(): void;
    abstract onConnect(): Promise<void>;
    abstract onSubscribe(): Promise<void>;
}
export declare class KafkaClient extends EventBus {
    private static _instance;
    private _isProducerReq;
    private _isConsumerReq;
    private _clientId;
    private _brokers;
    private _kafka;
    private _producer;
    private _consumer;
    private _producerConfig;
    private _consumerConfig;
    private _consumerRunConfig;
    private _listeners;
    private constructor();
    static getInstance(): KafkaClient;
    get producer(): Producer;
    get consumer(): Consumer;
    get isProducerReq(): boolean;
    get isConsumerReq(): boolean;
    set clientId(clientId: string);
    set brokers(brokers: string[]);
    set producerConfig(producerConfig: ProducerConfig);
    set consumerConfig(consumerConfig: ConsumerConfig);
    set consumerRunConfig(consumerRunConfig: ConsumerRunConfig);
    set listeners(listeners: Listener<any>[]);
    private producerInit;
    private consumerInit;
    setup(isProducerReq: boolean, isConsumerReq: boolean): void;
    init(): void;
    onConnect(): Promise<void>;
    onSubscribe(): Promise<void>;
}
