/// <reference types="node" />
/// <reference types="node" />
import socketIo, { Server, Socket } from 'socket.io';
import http from 'http';
import https from 'https';
import { Model } from 'mongoose';
declare abstract class BaseStorageConnect {
    abstract get io(): Server;
    abstract setIo(server: http.Server | https.Server, path?: string): void;
}
declare class SocketConnect implements BaseStorageConnect {
    private _io;
    constructor();
    get io(): socketIo.Server;
    setIo(server: http.Server | https.Server, path?: string): void;
}
/**
 * Socket authentication for an individual namespace.
 * @param secretKey
 * @returns
 */
declare function socketAuth<DecodedDataType>(secretKey: string): (socket: Socket, next: (err: Error | null, isSuccess: boolean) => void) => void;
declare function fetchSocketUserInfo<DocType>(collRef: Model<DocType>, projection?: Record<string, any>): (socket: Socket, next: (err: Error | null, isSuccess: boolean) => void) => Promise<void>;
export { BaseStorageConnect, SocketConnect, socketAuth, fetchSocketUserInfo };
