"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fetchSocketUserInfo = exports.socketAuth = exports.SocketConnect = exports.BaseStorageConnect = void 0;
var socket_io_1 = __importDefault(require("socket.io"));
var errors_1 = require("../errors");
var jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
var services_1 = require("../services");
var mongooseService = services_1.MongooseService.getInstance();
var BaseStorageConnect = /** @class */ (function () {
    function BaseStorageConnect() {
    }
    return BaseStorageConnect;
}());
exports.BaseStorageConnect = BaseStorageConnect;
;
var SocketConnect = /** @class */ (function () {
    function SocketConnect() {
        this._io = null;
    }
    ;
    Object.defineProperty(SocketConnect.prototype, "io", {
        get: function () {
            if (!this._io)
                throw new errors_1.GenericValidationError({ error: new Error("Setting io must be done before getting the socket"), errorCode: 500 });
            return this._io;
        },
        enumerable: false,
        configurable: true
    });
    ;
    SocketConnect.prototype.setIo = function (server, path) {
        this._io = (0, socket_io_1.default)(server, {
            path: path
        });
    };
    ;
    return SocketConnect;
}());
exports.SocketConnect = SocketConnect;
;
/**
 * Socket authentication for an individual namespace.
 * @param secretKey
 * @returns
 */
function socketAuth(secretKey) {
    //! Need to handle it for SSO authentication.
    var _auth = function (socket, next) {
        try {
            var token = socket.handshake.auth.token;
            try {
                if (token) {
                    var decoded = jsonwebtoken_1.default.verify(token, secretKey);
                    socket.request.decodedToken = decoded;
                }
                ;
            }
            catch (error) {
                throw new Error('Authentication error while connecting to socket');
            }
            ;
            next(null, true);
        }
        catch (error) {
            console.error("Error in authenticating socket :", error);
            next(error, false);
        }
        ;
    };
    return _auth;
}
exports.socketAuth = socketAuth;
;
function fetchSocketUserInfo(collRef, projection) {
    //! Need to handle it for SSO authentication.
    var _this = this;
    var _fetchUser = function (socket, next) { return __awaiter(_this, void 0, void 0, function () {
        var decodedToken, user, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    decodedToken = socket.request.decodedToken;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 4, , 5]);
                    if (!decodedToken) return [3 /*break*/, 3];
                    return [4 /*yield*/, mongooseService.findOne(collRef, { _id: decodedToken.id }, projection)];
                case 2:
                    user = _a.sent();
                    socket.request.user = user;
                    _a.label = 3;
                case 3:
                    ;
                    next(null, true);
                    return [3 /*break*/, 5];
                case 4:
                    error_1 = _a.sent();
                    console.error("Error in fetchSocketUserData :", error_1);
                    next(error_1, false);
                    return [3 /*break*/, 5];
                case 5:
                    ;
                    return [2 /*return*/];
            }
        });
    }); };
    return _fetchUser;
}
exports.fetchSocketUserInfo = fetchSocketUserInfo;
;
//! Is it necessary to use jwtAuth
// this._io.use(
//     jwtAuth.authenticate(
//         {
//             secret: nconf.get('privateKey'),
//             algorithm: 'HS256',
//         },
//         async function (payload, done) {
//             try {
//                 console.log('test Payload..test', payload);
//                 let db = getDbName(payload.type);
//                 console.log('test db :', db);
//                 let user = await eval(db).findOne(
//                     { _id: payload._id },
//                     {
//                         _id: 1,
//                         type: 1,
//                         socketMemoryIndex: 1,
//                         companyId: 1,
//                         displayName: 1,
//                     }
//                 );
//                 if (!user) {
//                     done(new Error('Could not find user in DB').message, false);
//                 }
//                 // if(user.status !== 'ACTIVE') {
//                 //     done(new Error(`User not activated`).message, false);
//                 // }
//                 done(null, user);
//             } catch (error) {
//                 console.log('error in jwtAuthenticate :', error);
//                 winston.error(JSON.stringify(error));
//                 done(error, null);
//             }
//         }
//     )
// );
