import KcAdminClient from 'keycloak-admin';
export declare abstract class SSOAuth {
    abstract get adminClient(): KcAdminClient;
    abstract set adminClient(adminClient: KcAdminClient);
    abstract set adminName(name: string);
    abstract set adminPassword(name: string);
    abstract set ssoGrantType(type: 'client_credentials' | 'password');
    abstract set ssoClientName(name: string);
    abstract set ssoRealmName(name: string);
    abstract get ssoRealmName(): string;
    abstract set ssoAuthRefreshTime(minutes: number);
    abstract auth(): Promise<boolean>;
    abstract refresh(): Promise<void>;
}
export declare class SSOConnect extends SSOAuth {
    private static _instance;
    private isRequired;
    private _kcAdminClient;
    private _adminName;
    private _adminPassword;
    private _ssoGrantType;
    private _ssoClientName;
    private _ssoRealmName;
    private _ssoAuthRefreshTime;
    private constructor();
    static getInstance(): SSOConnect;
    set adminClient(adminClient: KcAdminClient);
    get adminClient(): KcAdminClient;
    set adminName(name: string);
    set adminPassword(password: string);
    set ssoGrantType(type: 'client_credentials' | 'password');
    set ssoClientName(name: string);
    get ssoRealmName(): string;
    set ssoRealmName(name: string);
    set ssoAuthRefreshTime(minutes: number);
    auth(): Promise<boolean>;
    refresh(): Promise<void>;
}
