import { EventBannerConvertedFilenames, EventThumbnailConvertedFilenames, UserAvatarConvertedFilenames } from "../interfaces";
export interface BaseImageConversionHelper {
    getConvertedFileUrl(fileURL: string, convertedFilename: UserAvatarConvertedFilenames | EventThumbnailConvertedFilenames | EventBannerConvertedFilenames): string;
}
export declare class ImageConversionHelper implements BaseImageConversionHelper {
    private static _instance;
    private constructor();
    static getInstance(): BaseImageConversionHelper;
    /**
     *
     * @param fileURL example: https://s3.terrahost.com/bucketName/public/users/user_id/avatar/model.zip
     * @returns example: https://s3.terrahost.com/bucketName/public/users/user_id/avatar/240x240.webp
     */
    getConvertedFileUrl(fileURL: string, convertedFilename: UserAvatarConvertedFilenames | EventThumbnailConvertedFilenames | EventBannerConvertedFilenames): string;
}
