import express from 'express';
import { GenericValidationError } from '../errors';
export interface IResponse {
    data: any;
}
export declare class BaseResponse<T extends IResponse> {
    data: any;
}
export declare abstract class ResponseHandler {
    constructor();
    protected ok<T>(response: express.Response, data?: T): express.Response<IResponse>;
    protected created(response: express.Response): express.Response<any, Record<string, any>>;
    protected clientError(message?: string): GenericValidationError;
    protected unauthorized(message?: string): GenericValidationError;
    protected paymentRequired(message?: string): GenericValidationError;
    protected forbidden(message?: string): GenericValidationError;
    protected notFound(message?: string): GenericValidationError;
    protected conflict(message?: string): GenericValidationError;
    protected tooMany(message?: string): GenericValidationError;
    protected internalError(message?: string): GenericValidationError;
}
