"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResponseHandler = exports.BaseResponse = void 0;
var errors_1 = require("../errors");
;
var BaseResponse = /** @class */ (function () {
    function BaseResponse() {
    }
    return BaseResponse;
}());
exports.BaseResponse = BaseResponse;
;
var ResponseHandler = /** @class */ (function () {
    function ResponseHandler() {
    }
    ;
    ResponseHandler.prototype.ok = function (response, data) {
        try {
            if (!data)
                return response.status(200).send();
            response.type('application/json');
            return response.status(200).send({ data: data });
        }
        catch (error) {
            throw error;
        }
    };
    ;
    ResponseHandler.prototype.created = function (response) {
        return response.sendStatus(201);
    };
    ;
    ResponseHandler.prototype.clientError = function (message) {
        if (message === void 0) { message = "Bad Request"; }
        return new errors_1.GenericValidationError({ error: new Error(message), errorCode: 400 });
    };
    ;
    ResponseHandler.prototype.unauthorized = function (message) {
        if (message === void 0) { message = "Unauthorized"; }
        return new errors_1.GenericValidationError({ error: new Error(message), errorCode: 401 });
    };
    ;
    ResponseHandler.prototype.paymentRequired = function (message) {
        if (message === void 0) { message = "Payment required"; }
        return new errors_1.GenericValidationError({ error: new Error(message), errorCode: 402 });
    };
    ;
    ResponseHandler.prototype.forbidden = function (message) {
        if (message === void 0) { message = "Forbidden"; }
        return new errors_1.GenericValidationError({ error: new Error(message), errorCode: 403 });
    };
    ;
    ResponseHandler.prototype.notFound = function (message) {
        if (message === void 0) { message = "Not found"; }
        return new errors_1.GenericValidationError({ error: new Error(message), errorCode: 404 });
    };
    ;
    ResponseHandler.prototype.conflict = function (message) {
        if (message === void 0) { message = "Conflict"; }
        return new errors_1.GenericValidationError({ error: new Error(message), errorCode: 409 });
    };
    ;
    ResponseHandler.prototype.tooMany = function (message) {
        if (message === void 0) { message = "Too many requests"; }
        return new errors_1.GenericValidationError({ error: new Error(message), errorCode: 429 });
    };
    ;
    ResponseHandler.prototype.internalError = function (message) {
        if (message === void 0) { message = "Internal server error"; }
        return new errors_1.GenericValidationError({ error: new Error(message), errorCode: 500 });
    };
    ;
    return ResponseHandler;
}());
exports.ResponseHandler = ResponseHandler;
;
