import mongoose from 'mongoose';
export declare enum ApprovedChannelStateChangeLogStatus {
    ACTIVE = "ACTIVE",
    INACTIVE = "INACTIVE"
}
export interface ApprovedChannelStateChangeStaffDoc extends mongoose.Document {
    displayName: string;
    email: string;
}
export interface ApprovedChannelStateChangeLogsDoc extends mongoose.Document {
    staff: ApprovedChannelStateChangeStaffDoc;
    status: ApprovedChannelStateChangeLogStatus;
    remarks?: string;
    createdOn?: Date;
}
export declare enum ApprovedChannelBankDetailsStatus {
    NEW = "NEW",
    PARTIAL = "PARTIAL",
    COMPLETED = "COMPLETED"
}
export interface ApprovedChannelPayment extends mongoose.Document {
    platformChargesInPercent: number;
}
export interface ApprovedChannelCountry extends mongoose.Document {
    isoCode: string;
}
export interface ApprovedChannelBankDetails {
    accountId: string;
}
export declare const approvedChannelStateChangeStaffSchema: mongoose.Schema<ApprovedChannelStateChangeStaffDoc, any, any, any>;
export declare const approvedChannelStateChangeLogsSchema: mongoose.Schema<ApprovedChannelStateChangeLogsDoc, any, any, any>;
export declare const approvedChannelPaymentSchema: mongoose.Schema<ApprovedChannelPayment, any, any, any>;
export declare const approvedChannelCountrySchema: mongoose.Schema<ApprovedChannelCountry, any, any, any>;
export declare const approvedChannelBankDetailsSchema: mongoose.Schema<ApprovedChannelBankDetails, any, any, any>;
