import { Currency, OtherCategory } from "./common";
import mongoose from 'mongoose';
export declare enum EventThumbnailConvertedFilenames {
    WEB_240 = "240xh.webp",
    WEB_480 = "480xh.webp",
    WEB_720 = "720xh.webp",
    WEB_970 = "970xh.webp",
    WEB_1920 = "1920xh.webp",
    MOBILE_240 = "wx240.webp",
    MOBILE_480 = "wx480.webp",
    MOBILE_720 = "wx720.webp",
    MOBILE_970 = "wx970.webp",
    MOBILE_1920 = "wx1920.webp"
}
export declare enum EventBannerConvertedFilenames {
    WEB_240 = "240xh.webp",
    WEB_480 = "480xh.webp",
    WEB_720 = "720xh.webp",
    WEB_970 = "970xh.webp",
    WEB_1920 = "1920xh.webp",
    MOBILE_240 = "wx240.webp",
    MOBILE_480 = "wx480.webp",
    MOBILE_720 = "wx720.webp",
    MOBILE_970 = "wx970.webp",
    MOBILE_1920 = "wx1920.webp"
}
export interface Featuring {
    user: mongoose.Types.ObjectId;
    role: string;
    profilePic: string;
    description: string;
}
export interface Guest {
    email: string;
}
export interface EventTicketCost {
    price: number;
    currency: Currency;
    hasGuestPayment: boolean;
}
export interface EventOthers extends mongoose.Document {
    category?: OtherCategory;
}
export interface VenueDoc extends mongoose.Document {
    label: string;
    value: string;
}
export interface EventPayment extends mongoose.Document {
    productId: string;
    priceId: string;
    platformChargesInPercent: number;
    chargeId?: string;
}
export declare enum EventVisibility {
    PUBLIC = "PUBLIC",
    PRIVATE = "PRIVATE"
}
export declare const featuringSubSchema: mongoose.Schema<Featuring, any, any, any>;
export declare const guestSubSchema: mongoose.Schema<Guest, any, any, any>;
export declare const eventCostSubSchema: mongoose.Schema<EventTicketCost, any, any, any>;
export declare const eventOthersSubSchema: mongoose.Schema<EventOthers, any, any, any>;
export declare const venueSchema: mongoose.Schema<VenueDoc, any, any, any>;
export declare const eventPaymentSchema: mongoose.Schema<EventPayment, any, any, any>;
