"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.eventPaymentSchema = exports.venueSchema = exports.eventOthersSubSchema = exports.eventCostSubSchema = exports.guestSubSchema = exports.featuringSubSchema = exports.EventVisibility = exports.EventBannerConvertedFilenames = exports.EventThumbnailConvertedFilenames = void 0;
var common_1 = require("./common");
var mongoose_1 = __importDefault(require("mongoose"));
var services_1 = require("../services");
var mongooseSchemaService = services_1.MongooseSchemaService.getInstance();
var EventThumbnailConvertedFilenames;
(function (EventThumbnailConvertedFilenames) {
    EventThumbnailConvertedFilenames["WEB_240"] = "240xh.webp";
    EventThumbnailConvertedFilenames["WEB_480"] = "480xh.webp";
    EventThumbnailConvertedFilenames["WEB_720"] = "720xh.webp";
    EventThumbnailConvertedFilenames["WEB_970"] = "970xh.webp";
    EventThumbnailConvertedFilenames["WEB_1920"] = "1920xh.webp";
    EventThumbnailConvertedFilenames["MOBILE_240"] = "wx240.webp";
    EventThumbnailConvertedFilenames["MOBILE_480"] = "wx480.webp";
    EventThumbnailConvertedFilenames["MOBILE_720"] = "wx720.webp";
    EventThumbnailConvertedFilenames["MOBILE_970"] = "wx970.webp";
    EventThumbnailConvertedFilenames["MOBILE_1920"] = "wx1920.webp";
})(EventThumbnailConvertedFilenames = exports.EventThumbnailConvertedFilenames || (exports.EventThumbnailConvertedFilenames = {}));
;
var EventBannerConvertedFilenames;
(function (EventBannerConvertedFilenames) {
    EventBannerConvertedFilenames["WEB_240"] = "240xh.webp";
    EventBannerConvertedFilenames["WEB_480"] = "480xh.webp";
    EventBannerConvertedFilenames["WEB_720"] = "720xh.webp";
    EventBannerConvertedFilenames["WEB_970"] = "970xh.webp";
    EventBannerConvertedFilenames["WEB_1920"] = "1920xh.webp";
    EventBannerConvertedFilenames["MOBILE_240"] = "wx240.webp";
    EventBannerConvertedFilenames["MOBILE_480"] = "wx480.webp";
    EventBannerConvertedFilenames["MOBILE_720"] = "wx720.webp";
    EventBannerConvertedFilenames["MOBILE_970"] = "wx970.webp";
    EventBannerConvertedFilenames["MOBILE_1920"] = "wx1920.webp";
})(EventBannerConvertedFilenames = exports.EventBannerConvertedFilenames || (exports.EventBannerConvertedFilenames = {}));
;
;
;
;
;
;
;
var EventVisibility;
(function (EventVisibility) {
    EventVisibility["PUBLIC"] = "PUBLIC";
    EventVisibility["PRIVATE"] = "PRIVATE";
})(EventVisibility = exports.EventVisibility || (exports.EventVisibility = {}));
;
exports.featuringSubSchema = new mongoose_1.default.Schema({
    user: { type: mongoose_1.default.Types.ObjectId, required: [true, 'is a required field'] },
    role: { type: String, required: [true, 'is a required field'] },
    profilePic: { type: String, required: [true, 'is a required field'] },
    description: { type: String, required: [true, 'is a required field'] }
}, { _id: false });
exports.guestSubSchema = new mongoose_1.default.Schema({
    email: { type: String, required: [true, 'is a required field'] }
}, { _id: false });
exports.eventCostSubSchema = new mongoose_1.default.Schema({
    price: { type: Number, required: [true, 'is a required field'] },
    currency: { type: String, enum: common_1.Currency, required: [true, 'is a required field'] },
    hasGuestPayment: { type: Boolean, default: false, required: [true, 'is a required field'] }
}, { _id: false });
exports.eventOthersSubSchema = new mongoose_1.default.Schema({
    category: { type: common_1.OtherCategorySubSchema }
}, { _id: false });
exports.venueSchema = new mongoose_1.default.Schema({
    _id: { type: String, required: [true, 'is a required field'] },
    label: { type: String, required: [true, 'is a required field'] },
    value: { type: String, required: [true, 'is a required field'] }
}, { toJSON: { transform: mongooseSchemaService.transform } });
exports.eventPaymentSchema = new mongoose_1.default.Schema({
    productId: { type: String, required: [true, 'is a required field'] },
    priceId: { type: String, required: [true, 'is a required field'] },
    platformChargesInPercent: { type: Number, required: [true, 'is a required field'] },
    chargeId: { type: String }
}, { _id: false, id: false, toJSON: { transform: mongooseSchemaService.transform } });
