import { Topics } from "../";
import mongoose from 'mongoose';
import { AudioTracks, Subtitles, VideoOthers, VideoStatus, VideoTypes, Classification, Stream, Visibility } from "../video";
import { BannerTemplate, Cast, ThumbnailTemplate } from "../common";
export interface VideoCreatedEvent {
    topic: Topics.VIDEO_CREATED;
    data: {
        id: string;
        version: number;
        url: string;
        rawURL?: string;
        type?: VideoTypes;
        uploadId: string;
        transcodedBy: string;
        libraryId: string;
        stream?: Stream;
        title: string;
        description: string;
        status?: VideoStatus;
        category: string;
        tags?: string[];
        audioTracks?: AudioTracks[];
        subtitles?: Subtitles[];
        audiences: mongoose.Types.ObjectId[];
        thumbnail: ThumbnailTemplate;
        banner: BannerTemplate;
        casts?: Cast[];
        approvedChannelId: mongoose.Types.ObjectId;
        isScheduled?: boolean;
        releaseDate?: Date;
        visibility: Visibility;
        is360?: boolean;
        views?: number;
        others?: VideoOthers;
        classification: Classification;
        isDeleted?: boolean;
        creationDate?: Date;
        lastModifiedDate?: Date;
    };
}
