import mongoose from 'mongoose';
declare enum LandShapes {
    SQUARE = "SQUARE"
}
declare enum LandTypes {
    ROAD = "ROAD",
    LAND = "LAND",
    NON_SELLABLE_LAND = "NON_SELLABLE_LAND"
}
interface LandAxis {
    x: number;
    y: number;
}
interface LandMeasurements {
    width: number;
    height: number;
}
interface LandCoordinates {
    row: number;
    column: number;
}
interface LandInfo {
    type: LandTypes;
    name: string;
}
declare const landAxisSubSchema: mongoose.Schema<LandAxis, any, any, any>;
declare const landMeasurementsSubSchema: mongoose.Schema<LandMeasurements, any, any, any>;
declare const landCoordinatesSubSchema: mongoose.Schema<LandCoordinates, any, any, any>;
declare const landInfoSubSchema: mongoose.Schema<LandInfo, any, any, any>;
export { LandShapes, LandTypes, LandAxis, LandMeasurements, LandCoordinates, LandInfo, landAxisSubSchema, landMeasurementsSubSchema, landCoordinatesSubSchema, landInfoSubSchema };
