"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.landInfoSubSchema = exports.landCoordinatesSubSchema = exports.landMeasurementsSubSchema = exports.landAxisSubSchema = exports.LandTypes = exports.LandShapes = void 0;
var mongoose_1 = __importDefault(require("mongoose"));
var LandShapes;
(function (LandShapes) {
    LandShapes["SQUARE"] = "SQUARE";
})(LandShapes || (LandShapes = {}));
exports.LandShapes = LandShapes;
;
var LandTypes;
(function (LandTypes) {
    LandTypes["ROAD"] = "ROAD";
    LandTypes["LAND"] = "LAND";
    LandTypes["NON_SELLABLE_LAND"] = "NON_SELLABLE_LAND";
})(LandTypes || (LandTypes = {}));
exports.LandTypes = LandTypes;
;
;
;
;
;
var landAxisSubSchema = new mongoose_1.default.Schema({
    x: { type: Number, required: [true, 'is a required field'] },
    y: { type: Number, required: [true, 'is a required field'] }
}, { _id: false, id: false });
exports.landAxisSubSchema = landAxisSubSchema;
var landMeasurementsSubSchema = new mongoose_1.default.Schema({
    width: { type: Number, required: [true, 'is a required field'] },
    height: { type: Number, required: [true, 'is a required field'] }
}, { _id: false, id: false });
exports.landMeasurementsSubSchema = landMeasurementsSubSchema;
var landCoordinatesSubSchema = new mongoose_1.default.Schema({
    row: { type: Number, required: [true, 'is a required field'] },
    column: { type: Number, required: [true, 'is a required field'] }
}, { _id: false, id: false });
exports.landCoordinatesSubSchema = landCoordinatesSubSchema;
var landInfoSubSchema = new mongoose_1.default.Schema({
    type: { type: String, enum: LandTypes, required: [true, 'is a required field'] },
    name: { type: String, required: [true, 'is a required field'] }
}, { _id: false, id: false });
exports.landInfoSubSchema = landInfoSubSchema;
