import mongoose from 'mongoose';
interface FCMMessage {
    title: string;
    body: string;
}
declare enum NotificationTypes {
    WELCOME = "WELCOME",
    BOOKING_CONFIRM = "BOOKING_CONFIRM",
    BOOKING_CANCEL = "BOOKING_CANCEL",
    EVENT_REMINDER = "EVENT_REMINDER",
    HOST_EVENT_CANCEL = "HOST_EVENT_CANCEL",
    CHANNEL_APPLICATION = "CHANNEL_APPLICATION",
    CHANNEL_REVIEW = "CHANNEL_REVIEW",
    CHANNEL_CONFIRMATION = "CHANNEL_CONFIRMATION",
    CHANNEL_REJECTION = "CHANNEL_REJECTION",
    CHANNEL_DELETION = "CHANNEL_DELETION",
    FRIEND_REQUEST = "FRIEND_REQUEST",
    FRIEND_REQUEST_ACCEPTED = "FRIEND_REQUEST_ACCEPTED"
}
interface NotificationSender {
    user?: mongoose.Types.ObjectId;
    channelStaff?: mongoose.Types.ObjectId;
    admin?: mongoose.Types.ObjectId;
    system?: mongoose.Types.ObjectId;
}
interface NotificationReceiver {
    user?: mongoose.Types.ObjectId;
    channelStaff?: mongoose.Types.ObjectId;
    admin?: mongoose.Types.ObjectId;
}
interface NotificationPayload {
    image?: string;
    email?: string;
    eventId?: string;
    channelId?: string;
}
declare const notificationSenderSubSchema: mongoose.Schema<NotificationSender, any, any, any>;
declare const notificationReceiverSubSchema: mongoose.Schema<NotificationReceiver, any, any, any>;
declare const notificationPayloadSubSchema: mongoose.Schema<NotificationPayload & {
    id: string;
}, any, any, any>;
export { FCMMessage, NotificationTypes, NotificationSender, NotificationReceiver, NotificationPayload, notificationSenderSubSchema, notificationReceiverSubSchema, notificationPayloadSubSchema };
