"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.notificationPayloadSubSchema = exports.notificationReceiverSubSchema = exports.notificationSenderSubSchema = exports.NotificationTypes = void 0;
var mongoose_1 = __importDefault(require("mongoose"));
;
var NotificationTypes;
(function (NotificationTypes) {
    NotificationTypes["WELCOME"] = "WELCOME";
    NotificationTypes["BOOKING_CONFIRM"] = "BOOKING_CONFIRM";
    NotificationTypes["BOOKING_CANCEL"] = "BOOKING_CANCEL";
    NotificationTypes["EVENT_REMINDER"] = "EVENT_REMINDER";
    NotificationTypes["HOST_EVENT_CANCEL"] = "HOST_EVENT_CANCEL";
    NotificationTypes["CHANNEL_APPLICATION"] = "CHANNEL_APPLICATION";
    NotificationTypes["CHANNEL_REVIEW"] = "CHANNEL_REVIEW";
    NotificationTypes["CHANNEL_CONFIRMATION"] = "CHANNEL_CONFIRMATION";
    NotificationTypes["CHANNEL_REJECTION"] = "CHANNEL_REJECTION";
    NotificationTypes["CHANNEL_DELETION"] = "CHANNEL_DELETION";
    NotificationTypes["FRIEND_REQUEST"] = "FRIEND_REQUEST";
    NotificationTypes["FRIEND_REQUEST_ACCEPTED"] = "FRIEND_REQUEST_ACCEPTED";
})(NotificationTypes || (NotificationTypes = {}));
exports.NotificationTypes = NotificationTypes;
;
;
;
;
var notificationSenderSubSchema = new mongoose_1.default.Schema({
    user: { type: mongoose_1.default.Types.ObjectId, ref: 'users' },
    channelStaff: { type: mongoose_1.default.Types.ObjectId, ref: 'channelstaffs' },
    admin: { type: mongoose_1.default.Types.ObjectId, ref: 'staffs' },
    system: { type: mongoose_1.default.Types.ObjectId, ref: 'notifications' }
}, { _id: false, id: false });
exports.notificationSenderSubSchema = notificationSenderSubSchema;
var notificationReceiverSubSchema = new mongoose_1.default.Schema({
    user: { type: mongoose_1.default.Types.ObjectId, ref: 'users' },
    channelStaff: { type: mongoose_1.default.Types.ObjectId, ref: 'channelstaffs' },
    admin: { type: mongoose_1.default.Types.ObjectId, ref: 'staffs' },
}, { _id: false, id: false });
exports.notificationReceiverSubSchema = notificationReceiverSubSchema;
var notificationPayloadSubSchema = new mongoose_1.default.Schema({
    id: { type: String, required: [true, 'is a required field'] },
    image: { type: String },
    email: { type: String },
    eventId: { type: String },
    channelId: { type: String }
}, { _id: false, id: false });
exports.notificationPayloadSubSchema = notificationPayloadSubSchema;
