"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transactionDisbursementStatusSchema = exports.transactionChargeSubSchema = exports.transactionDisbursementSubSchema = exports.transactionRefundSubSchema = exports.transactionAccountDetailsSubSchema = exports.transactionChannelStaffSubSchema = exports.transactionApprovedChannelSubSchema = exports.disbursementTransctionsSubSchema = exports.transactionEventSubSchema = exports.transactionUserSubSchema = exports.TransactionOculusPaymentStatus = exports.TransactionPaymentModes = exports.TransactionRefundStatus = exports.TransactionDisbursementStatus = exports.TransactionStripeRefundStatus = exports.TransactionStripeDisbursementStatus = exports.TransactionStripePaymentStatus = exports.TransactionSubType = exports.TransactionType = void 0;
var mongoose_1 = __importDefault(require("mongoose"));
var channel_staff_1 = require("./channel-staff");
var event_1 = require("./event");
var user_1 = require("./user");
var TransactionType;
(function (TransactionType) {
    TransactionType["CREDIT"] = "CREDIT";
    TransactionType["DEBIT"] = "DEBIT";
})(TransactionType = exports.TransactionType || (exports.TransactionType = {}));
;
var TransactionSubType;
(function (TransactionSubType) {
    TransactionSubType["CAPTURE"] = "CAPTURE";
    TransactionSubType["REFUND"] = "REFUND";
    TransactionSubType["CHANNEL_OWNER_DISBURSEMENT"] = "CHANNEL_OWNER_DISBURSEMENT";
    TransactionSubType["OWNER_DISBURSEMENT"] = "OWNER_DISBURSEMENT";
})(TransactionSubType = exports.TransactionSubType || (exports.TransactionSubType = {}));
;
var TransactionStripePaymentStatus;
(function (TransactionStripePaymentStatus) {
    TransactionStripePaymentStatus["PAID"] = "paid";
    TransactionStripePaymentStatus["UNPAID"] = "unpaid";
    TransactionStripePaymentStatus["NO_PAYMENT_REQUIRED"] = "no_payment_required";
})(TransactionStripePaymentStatus = exports.TransactionStripePaymentStatus || (exports.TransactionStripePaymentStatus = {}));
;
var TransactionStripeDisbursementStatus;
(function (TransactionStripeDisbursementStatus) {
    TransactionStripeDisbursementStatus["PAID"] = "paid";
    TransactionStripeDisbursementStatus["PENDING"] = "pending";
    TransactionStripeDisbursementStatus["IN_TRANSIT"] = "in_transit";
    TransactionStripeDisbursementStatus["CANCELED"] = "canceled";
    TransactionStripeDisbursementStatus["FAILED"] = "failed";
})(TransactionStripeDisbursementStatus = exports.TransactionStripeDisbursementStatus || (exports.TransactionStripeDisbursementStatus = {}));
;
var TransactionStripeRefundStatus;
(function (TransactionStripeRefundStatus) {
    TransactionStripeRefundStatus["PENDING"] = "pending";
    TransactionStripeRefundStatus["REQUIRES_ACTION"] = "requires_action";
    TransactionStripeRefundStatus["SUCCEEDED"] = "succeeded";
    TransactionStripeRefundStatus["FAILED"] = "failed";
    TransactionStripeRefundStatus["CANCELED"] = "canceled";
})(TransactionStripeRefundStatus = exports.TransactionStripeRefundStatus || (exports.TransactionStripeRefundStatus = {}));
;
var TransactionDisbursementStatus;
(function (TransactionDisbursementStatus) {
    TransactionDisbursementStatus["NOT_STARTED"] = "NOT_STARTED";
    TransactionDisbursementStatus["IN_PROGRESS"] = "IN_PROGRESS";
    TransactionDisbursementStatus["COMPLETED"] = "COMPLETED";
    TransactionDisbursementStatus["FAILED"] = "FAILED";
})(TransactionDisbursementStatus = exports.TransactionDisbursementStatus || (exports.TransactionDisbursementStatus = {}));
;
var TransactionRefundStatus;
(function (TransactionRefundStatus) {
    TransactionRefundStatus["NOT_STARTED"] = "NOT_STARTED";
    TransactionRefundStatus["IN_PROGRESS"] = "IN_PROGRESS";
    TransactionRefundStatus["COMPLETED"] = "COMPLETED";
    TransactionRefundStatus["FAILED"] = "FAILED";
})(TransactionRefundStatus = exports.TransactionRefundStatus || (exports.TransactionRefundStatus = {}));
;
var TransactionPaymentModes;
(function (TransactionPaymentModes) {
    TransactionPaymentModes["STRIPE"] = "STRIPE";
    TransactionPaymentModes["OCULUS_IN_APP"] = "OCULUS_IN_APP";
})(TransactionPaymentModes = exports.TransactionPaymentModes || (exports.TransactionPaymentModes = {}));
;
var TransactionOculusPaymentStatus;
(function (TransactionOculusPaymentStatus) {
    TransactionOculusPaymentStatus["PAID"] = "paid";
})(TransactionOculusPaymentStatus = exports.TransactionOculusPaymentStatus || (exports.TransactionOculusPaymentStatus = {}));
;
;
;
;
;
;
;
;
;
;
;
exports.transactionUserSubSchema = new mongoose_1.default.Schema({
    userId: { type: mongoose_1.default.Types.ObjectId, ref: 'users', required: [true, 'is a required field'] },
    displayName: { type: String, required: [true, 'is a required field'] },
    email: { type: String, required: [true, 'is a required field'] },
    role: { type: String, required: [true, 'is a required field'] },
    avatar: { type: user_1.avatarSchema }
});
exports.transactionEventSubSchema = new mongoose_1.default.Schema({
    eventId: { type: mongoose_1.default.Types.ObjectId, ref: 'events', required: [true, 'is a required field'] },
    name: { type: String, required: [true, 'is a required field'] },
    type: { type: String, ref: 'eventtypes', required: [true, 'is a required field'] },
    venue: { type: String },
    category: { type: String },
    startTime: { type: Date, required: [true, 'is a required field'] },
    endTime: { type: Date, required: [true, 'is a required field'] },
    ticketCost: { type: event_1.eventCostSubSchema },
    payment: { type: event_1.eventPaymentSchema }
});
exports.disbursementTransctionsSubSchema = new mongoose_1.default.Schema({
    transactionId: { type: mongoose_1.default.Types.ObjectId, ref: 'transactions', required: [true, 'is a required field'] },
    chargeId: { type: String, required: [true, 'is a required field'] },
    currency: { type: String, required: [true, 'is a required field'] },
    price: { type: Number, required: [true, 'is a required field'] }
}, { _id: false, id: false });
exports.transactionApprovedChannelSubSchema = new mongoose_1.default.Schema({
    approvedChannelId: { type: mongoose_1.default.Types.ObjectId, ref: 'approvedchannels', required: [true, 'is a required field'] },
    name: { type: String, required: [true, 'is a required field'] }
}, { _id: false, id: false });
exports.transactionChannelStaffSubSchema = new mongoose_1.default.Schema({
    channelStaffId: { type: mongoose_1.default.Types.ObjectId, ref: 'channelstaffs', required: [true, 'is a required field'] },
    displayName: { type: String, required: [true, 'is a required field'] },
    email: { type: String, required: [true, 'is a required field'] },
    role: { type: String, enum: channel_staff_1.ChannelStaffRoles, required: [true, 'is a required field'] },
    profilePic: { type: String }
}, { _id: false, id: false });
exports.transactionAccountDetailsSubSchema = new mongoose_1.default.Schema({
    accountId: { type: String, required: [true, 'is a required field'] },
});
exports.transactionRefundSubSchema = new mongoose_1.default.Schema({
    refundId: { type: String },
    currency: { type: String },
    amount: { type: Number },
    coins: { type: Number }
});
exports.transactionDisbursementSubSchema = new mongoose_1.default.Schema({
    disbursementId: { type: String },
    currency: { type: String, required: [true, 'is a required field'] },
    amount: { type: Number, required: [true, 'is a required field'] }
});
exports.transactionChargeSubSchema = new mongoose_1.default.Schema({
    chargeId: { type: String },
    currency: { type: String },
    amount: { type: Number },
    coins: { type: Number }
});
exports.transactionDisbursementStatusSchema = new mongoose_1.default.Schema({
    owner: { type: String, enum: TransactionDisbursementStatus },
    channelOwner: { type: String, enum: TransactionDisbursementStatus }
});
