import mongoose from 'mongoose';
export declare enum UserApprovalStatus {
    PENDING = "PENDING",
    RECOMMENDED = "RECOMMENDED",
    APPROVED = "APPROVED",
    REJECTED = "REJECTED"
}
export interface UserApprovalRecommendedBy {
    user: string | mongoose.Types.ObjectId;
    status?: UserApprovalStatus;
    recommendedOn?: Date;
}
export interface UserApprovalApprovedBy {
    user: string | mongoose.Types.ObjectId;
    status?: UserApprovalStatus;
    approvedOn?: Date;
}
export interface UserApprovalDoc extends mongoose.Document {
    user: mongoose.Types.ObjectId;
    status?: UserApprovalStatus;
    recommendedBy: UserApprovalRecommendedBy[];
    approvedBy?: UserApprovalApprovedBy[];
    description: string;
    isDeleted?: boolean;
    creationDate?: Date;
    lastModifiedDate?: Date;
}
export declare const userApprovalRecommendedBySchema: mongoose.Schema<UserApprovalRecommendedBy, any, any, any>;
export declare const userApprovalApprovedBySchema: mongoose.Schema<UserApprovalApprovedBy, any, any, any>;
