"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.userApprovalApprovedBySchema = exports.userApprovalRecommendedBySchema = exports.UserApprovalStatus = void 0;
var mongoose_1 = __importDefault(require("mongoose"));
var services_1 = require("../services");
var mongooseSchemaService = services_1.MongooseSchemaService.getInstance();
var UserApprovalStatus;
(function (UserApprovalStatus) {
    UserApprovalStatus["PENDING"] = "PENDING";
    UserApprovalStatus["RECOMMENDED"] = "RECOMMENDED";
    UserApprovalStatus["APPROVED"] = "APPROVED";
    UserApprovalStatus["REJECTED"] = "REJECTED";
})(UserApprovalStatus = exports.UserApprovalStatus || (exports.UserApprovalStatus = {}));
;
;
;
;
exports.userApprovalRecommendedBySchema = new mongoose_1.default.Schema({
    user: { type: mongoose_1.default.Types.ObjectId, ref: "users", required: [true, 'is a required field'] },
    status: { type: String, enum: UserApprovalStatus, default: UserApprovalStatus.PENDING, required: [true, 'is a required field'] },
    recommendedOn: { type: Date, required: [true, 'is a required field'] }
}, { _id: false, toJSON: { transform: mongooseSchemaService.transform } });
exports.userApprovalApprovedBySchema = new mongoose_1.default.Schema({
    user: { type: mongoose_1.default.Types.ObjectId, ref: "staffs", required: [true, 'is a required field'] },
    status: { type: String, enum: UserApprovalStatus, required: [true, 'is a required field'] },
    approvedOn: { type: Date, required: [true, 'is a required field'] }
}, { _id: false, toJSON: { transform: mongooseSchemaService.transform } });
