import mongoose from 'mongoose';
declare enum UserStatus {
    NEW = "NEW",
    INVITED = "INVITED",
    ACTIVE = "ACTIVE"
}
declare enum Gender {
    MALE = "MALE",
    FEMALE = "FEMALE"
}
declare enum UserRoles {
    VISITOR = "VISITOR",
    MEMBER = "MEMBER",
    CITIZEN = "CITIZEN",
    ELDER = "ELDER"
}
declare enum UserAvatarConvertedFilenames {
    AVATAR_240 = "240x240.webp",
    AVATAR_480 = "480x480.webp",
    AVATAR_720 = "720x720.webp",
    AVATAR_970 = "970x970.webp",
    AVATAR_1920 = "1920x1920.webp"
}
declare enum UserTypes {
    USER = "USER",
    CHANNEL_USER = "CHANNEL_USER",
    ADMIN_USER = "ADMIN_USER"
}
interface UserAvatar {
    hair: string;
    head: string;
    eyebrow: string;
    outfit: string;
    beard: string;
    display: string;
}
declare const avatarSchema: mongoose.Schema<any, mongoose.Model<any, any, any, any>, any, any>;
interface PrintifyTokens {
    accessToken: string;
    refreshToken: string;
    expiresAt: string;
}
interface UserPrintify {
    tokens?: PrintifyTokens;
}
declare const printifyTokensSchema: mongoose.Schema<PrintifyTokens, any, any, any>;
declare const userPrintifySchema: mongoose.Schema<UserPrintify, any, any, any>;
export { UserStatus, Gender, UserRoles, UserAvatar, UserAvatarConvertedFilenames, avatarSchema, PrintifyTokens, UserPrintify, printifyTokensSchema, userPrintifySchema, UserTypes };
