"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserTypes = exports.userPrintifySchema = exports.printifyTokensSchema = exports.avatarSchema = exports.UserAvatarConvertedFilenames = exports.UserRoles = exports.Gender = exports.UserStatus = void 0;
var mongoose_1 = __importDefault(require("mongoose"));
var UserStatus;
(function (UserStatus) {
    UserStatus["NEW"] = "NEW";
    UserStatus["INVITED"] = "INVITED";
    UserStatus["ACTIVE"] = "ACTIVE";
})(UserStatus || (UserStatus = {}));
exports.UserStatus = UserStatus;
;
var Gender;
(function (Gender) {
    Gender["MALE"] = "MALE";
    Gender["FEMALE"] = "FEMALE";
})(Gender || (Gender = {}));
exports.Gender = Gender;
;
var UserRoles;
(function (UserRoles) {
    UserRoles["VISITOR"] = "VISITOR";
    UserRoles["MEMBER"] = "MEMBER";
    UserRoles["CITIZEN"] = "CITIZEN";
    UserRoles["ELDER"] = "ELDER";
})(UserRoles || (UserRoles = {}));
exports.UserRoles = UserRoles;
;
var UserAvatarConvertedFilenames;
(function (UserAvatarConvertedFilenames) {
    UserAvatarConvertedFilenames["AVATAR_240"] = "240x240.webp";
    UserAvatarConvertedFilenames["AVATAR_480"] = "480x480.webp";
    UserAvatarConvertedFilenames["AVATAR_720"] = "720x720.webp";
    UserAvatarConvertedFilenames["AVATAR_970"] = "970x970.webp";
    UserAvatarConvertedFilenames["AVATAR_1920"] = "1920x1920.webp";
})(UserAvatarConvertedFilenames || (UserAvatarConvertedFilenames = {}));
exports.UserAvatarConvertedFilenames = UserAvatarConvertedFilenames;
;
var UserTypes;
(function (UserTypes) {
    UserTypes["USER"] = "USER";
    UserTypes["CHANNEL_USER"] = "CHANNEL_USER";
    UserTypes["ADMIN_USER"] = "ADMIN_USER";
})(UserTypes || (UserTypes = {}));
exports.UserTypes = UserTypes;
;
;
var avatarSchema = new mongoose_1.default.Schema({
    hair: { type: String },
    head: { type: String },
    eyebrow: { type: String },
    outfit: { type: String },
    beard: { type: String },
    display: { type: String }
});
exports.avatarSchema = avatarSchema;
;
;
var printifyTokensSchema = new mongoose_1.default.Schema({
    accessToken: { type: String, required: [true, 'is a required field'] },
    refreshToken: { type: String, required: [true, 'is a required field'] },
    expiresAt: { type: String, required: [true, 'is a required field'] }
}, { _id: false, id: false });
exports.printifyTokensSchema = printifyTokensSchema;
var userPrintifySchema = new mongoose_1.default.Schema({
    tokens: { type: printifyTokensSchema }
}, { _id: false, id: false });
exports.userPrintifySchema = userPrintifySchema;
