import mongoose from 'mongoose';
import { OtherCategory } from './common';
export declare enum VideoTypes {
    PRE_RECORDED = "PRE_RECORDED",
    LIVE = "LIVE"
}
export interface AudioTracks {
    language: String;
    url?: string;
}
export interface Subtitles {
    language: String;
    url: string;
}
export declare enum VideoStatus {
    TRANSCODING = "TRANSCODING",
    PUBLISH = "PUBLISH",
    STREAMING = "STREAMING"
}
export declare enum Visibility {
    PUBLIC = "PUBLIC",
    PRIVATE = "PRIVATE",
    UNLIST = "UNLIST"
}
export declare enum Classification {
    _360 = "_360",
    _180 = "_180",
    _2D = "_2D"
}
export interface VideoOthers extends mongoose.Document {
    category?: OtherCategory;
}
export interface Stream extends mongoose.Document {
    id: string;
    url: string;
    key: string;
    language: mongoose.Types.ObjectId;
}
export declare const audioTracksSubSchema: mongoose.Schema<AudioTracks, any, any, any>;
export declare const subtitlesSubSchema: mongoose.Schema<Subtitles, any, any, any>;
export declare const videoOthersSubSchema: mongoose.Schema<VideoOthers, any, any, any>;
export declare const streamSchema: mongoose.Schema<Stream, any, any, any>;
