"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.streamSchema = exports.videoOthersSubSchema = exports.subtitlesSubSchema = exports.audioTracksSubSchema = exports.Classification = exports.Visibility = exports.VideoStatus = exports.VideoTypes = void 0;
var mongoose_1 = __importDefault(require("mongoose"));
var common_1 = require("./common");
var VideoTypes;
(function (VideoTypes) {
    VideoTypes["PRE_RECORDED"] = "PRE_RECORDED";
    VideoTypes["LIVE"] = "LIVE";
})(VideoTypes = exports.VideoTypes || (exports.VideoTypes = {}));
;
;
;
var VideoStatus;
(function (VideoStatus) {
    VideoStatus["TRANSCODING"] = "TRANSCODING";
    VideoStatus["PUBLISH"] = "PUBLISH";
    VideoStatus["STREAMING"] = "STREAMING";
})(VideoStatus = exports.VideoStatus || (exports.VideoStatus = {}));
;
var Visibility;
(function (Visibility) {
    Visibility["PUBLIC"] = "PUBLIC";
    Visibility["PRIVATE"] = "PRIVATE";
    Visibility["UNLIST"] = "UNLIST";
})(Visibility = exports.Visibility || (exports.Visibility = {}));
;
var Classification;
(function (Classification) {
    Classification["_360"] = "_360";
    Classification["_180"] = "_180";
    Classification["_2D"] = "_2D";
})(Classification = exports.Classification || (exports.Classification = {}));
;
;
;
exports.audioTracksSubSchema = new mongoose_1.default.Schema({
    language: { type: String, ref: 'languages', required: [true, 'is a required field'] },
    url: { type: String, default: "" }
}, { _id: false });
exports.subtitlesSubSchema = new mongoose_1.default.Schema({
    language: { type: String, ref: 'languages', required: [true, 'is a required field'] },
    url: { type: String, required: [true, 'is a required field'] }
}, { _id: false });
exports.videoOthersSubSchema = new mongoose_1.default.Schema({
    category: { type: common_1.OtherCategorySubSchema }
}, { _id: false });
exports.streamSchema = new mongoose_1.default.Schema({
    id: { type: String, required: [true, 'is a required field'] },
    url: { type: String, required: [true, 'is a required field'] },
    key: { type: String, required: [true, 'is a required field'] },
    language: { type: String, ref: 'languages', required: [true, 'is a required field'] }
}, { _id: false });
