"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseLoader = exports.Loader = void 0;
var https_1 = __importDefault(require("https"));
var errors_1 = require("../errors");
var foundation_1 = require("../foundation");
var keycloak_admin_1 = __importDefault(require("keycloak-admin"));
var BaseLoader = /** @class */ (function () {
    function BaseLoader() {
    }
    return BaseLoader;
}());
exports.BaseLoader = BaseLoader;
;
var Loader = /** @class */ (function (_super) {
    __extends(Loader, _super);
    function Loader() {
        var _this = _super.call(this) || this;
        _this._isProcessRequired = false;
        _this._isNconfRequired = false;
        _this._isWinstonRequired = false;
        _this._isDatabaseRequired = false;
        _this._isCronRequired = false;
        _this._isRoutesRequired = false;
        _this._isStorageRequired = false;
        _this._isKafkaClientRequired = false;
        _this._isSSORequired = false;
        _this._isStripeClientRequired = false;
        _this._isNotificationRequired = false;
        _this._environment = process.env.NODE_ENV;
        _this._config = null;
        _this._logPath = null;
        _this._mongoose = null;
        _this._dbConnectionString = null;
        _this._authUrl = null;
        _this._adminName = null;
        _this._adminPassword = null;
        _this._ssoGrantType = null;
        _this._ssoClientName = null;
        _this._ssoRealmName = null;
        _this._ssoAuthRefreshTime = null;
        _this._cronJob = null;
        _this._routes = null;
        _this._app = null;
        _this._clientId = null;
        _this._brokers = null;
        _this._producerConfig = null;
        _this._consumerConfig = null;
        _this._consumerRunConfig = null;
        _this._listeners = null;
        return _this;
    }
    ;
    Loader.getInstance = function () {
        if (!Loader._instance)
            Loader._instance = new Loader();
        return Loader._instance;
    };
    ;
    Object.defineProperty(Loader.prototype, "config", {
        set: function (config) {
            this._config = config;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "logPath", {
        set: function (logPath) {
            this._logPath = logPath;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "mongoose", {
        set: function (mongoose) {
            this._mongoose = mongoose;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "dbConnectionString", {
        set: function (dbConnectionString) {
            this._dbConnectionString = dbConnectionString;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "authUrl", {
        set: function (url) {
            this._authUrl = url;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "adminName", {
        set: function (name) {
            this._adminName = name;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "adminPassword", {
        set: function (password) {
            this._adminPassword = password;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "ssoGrantType", {
        set: function (type) {
            this._ssoGrantType = type;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "ssoClientName", {
        set: function (name) {
            this._ssoClientName = name;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "ssoAuthRefreshTime", {
        set: function (minutes) {
            this._ssoAuthRefreshTime = minutes;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "ssoRealmName", {
        set: function (name) {
            this._ssoRealmName = name;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "cronJob", {
        set: function (cronJob) {
            this._cronJob = cronJob;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "routes", {
        set: function (routes) {
            this._routes = routes;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "app", {
        set: function (app) {
            this._app = app;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "clientId", {
        set: function (clientId) {
            this._clientId = clientId;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "brokers", {
        set: function (brokers) {
            this._brokers = brokers;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "producerConfig", {
        set: function (config) {
            this._producerConfig = config;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "consumerConfig", {
        set: function (config) {
            this._consumerConfig = config;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "consumerRunConfig", {
        set: function (consumerRunConfig) {
            this._consumerRunConfig = consumerRunConfig;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(Loader.prototype, "listeners", {
        set: function (listeners) {
            this._listeners = listeners;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Loader.prototype.setup = function (loadModules) {
        this._isProcessRequired = loadModules.isProcessRequired;
        this._isNconfRequired = loadModules.isNconfRequired;
        this._isWinstonRequired = loadModules.isWinstonRequired;
        this._isDatabaseRequired = loadModules.isDatabaseRequired;
        this._isCronRequired = loadModules.isCronRequired;
        this._isRoutesRequired = loadModules.isRoutesRequired;
        this._isStorageRequired = loadModules.isStorageRequired;
        this._isKafkaClientRequired = loadModules.isKafkaClientRequired;
        this._isSSORequired = loadModules.isSSORequired;
        this._isStripeClientRequired = loadModules.isStripeClientRequired;
        this._isNotificationRequired = loadModules.isNotificationRequired;
    };
    ;
    Loader.prototype.load = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _process, nconf, winston, db, sso, storage, stripe, kafkaClient, fcmConnect, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 9, , 10]);
                        // Handling unhandled promise rejections and uncaught exceptions.
                        if (this._isProcessRequired) {
                            _process = foundation_1.UnHandledAndUnCaught.getInstance();
                            _process.onListener(process);
                        }
                        ;
                        // Getting environment variable using nconf.
                        if (this._isNconfRequired) {
                            if (!this._config)
                                throw new errors_1.GenericValidationError({ error: new Error("_config is required to setup the NCONF"), errorCode: 500 });
                            nconf = foundation_1.Nconf.getInstance();
                            nconf.set(this._environment, this._config);
                        }
                        ;
                        // Server logs are maintained using winston logger.
                        if (this._isWinstonRequired) {
                            if (!this._logPath)
                                throw new errors_1.GenericValidationError({ error: new Error("_logPath is required to setup the winston"), errorCode: 500 });
                            winston = foundation_1.WinstonLogger.getInstance();
                            winston.start(this._environment, this._logPath);
                        }
                        ;
                        if (!this._isDatabaseRequired) return [3 /*break*/, 2];
                        if (!this._dbConnectionString)
                            throw new errors_1.GenericValidationError({ error: new Error("_dbConnectionString is required to connect to the db"), errorCode: 500 });
                        if (!this._mongoose)
                            throw new errors_1.GenericValidationError({ error: new Error("_mongoose is required to connect to the db"), errorCode: 500 });
                        db = foundation_1.MongooseConnect.getInstance();
                        db.mongoose = this._mongoose;
                        db.dbConnectionString = this._dbConnectionString;
                        return [4 /*yield*/, db.connect()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        ;
                        if (!this._isSSORequired) return [3 /*break*/, 5];
                        if (!this._authUrl)
                            throw new errors_1.GenericValidationError({ error: new Error("_authUrl is required to authenticate the SSO"), errorCode: 500 });
                        if (!this._adminName)
                            throw new errors_1.GenericValidationError({ error: new Error("_adminName is required to authenticate the SSO"), errorCode: 500 });
                        if (!this._adminPassword)
                            throw new errors_1.GenericValidationError({ error: new Error("_adminPassword is required to authenticate the SSO"), errorCode: 500 });
                        if (!this._ssoGrantType)
                            throw new errors_1.GenericValidationError({ error: new Error("_ssoGrantType is required to authenticate the SSO"), errorCode: 500 });
                        if (!this._ssoClientName)
                            throw new errors_1.GenericValidationError({ error: new Error("_ssoClientName is required to authenticate the SSO"), errorCode: 500 });
                        if (!this._ssoRealmName)
                            throw new errors_1.GenericValidationError({ error: new Error("_ssoRealmName is required to authenticate the SSO"), errorCode: 500 });
                        if (!this._ssoAuthRefreshTime)
                            throw new errors_1.GenericValidationError({ error: new Error("_ssoAuthRefreshTime is required to authenticate the SSO"), errorCode: 500 });
                        sso = foundation_1.SSOConnect.getInstance();
                        sso.adminClient = new keycloak_admin_1.default({ baseUrl: this._authUrl, requestConfig: { httpsAgent: new https_1.default.Agent({ keepAlive: true }) } });
                        sso.adminName = this._adminName;
                        sso.adminPassword = this._adminPassword;
                        sso.ssoGrantType = this._ssoGrantType;
                        sso.ssoClientName = this._ssoClientName;
                        sso.ssoRealmName = this._ssoRealmName;
                        sso.ssoAuthRefreshTime = this._ssoAuthRefreshTime;
                        return [4 /*yield*/, sso.auth()];
                    case 3:
                        _a.sent();
                        // Refreshing Strategy for SSO (keycloak).
                        return [4 /*yield*/, sso.refresh()];
                    case 4:
                        // Refreshing Strategy for SSO (keycloak).
                        _a.sent();
                        _a.label = 5;
                    case 5:
                        // Storage configuration
                        if (this._isStorageRequired) {
                            storage = foundation_1.S3StorageConnect.getInstance();
                            storage.setConfig();
                        }
                        ;
                        // Stripe configuration
                        if (this._isStripeClientRequired) {
                            stripe = foundation_1.StripeConnect.getInstance();
                            stripe.setConfig();
                        }
                        ;
                        // Starting to run cronjobs.
                        if (this._isCronRequired) {
                            if (!this._cronJob)
                                throw new errors_1.GenericValidationError({ error: new Error("_cronJob instance is required to run it"), errorCode: 500 });
                            this._cronJob.run();
                        }
                        ;
                        // Startup Routes.
                        if (this._isRoutesRequired) {
                            if (!this._routes)
                                throw new errors_1.GenericValidationError({ error: new Error("_routes instance is required to run it"), errorCode: 500 });
                            if (!this._app)
                                throw new errors_1.GenericValidationError({ error: new Error("_app(Express app instance) is required to listen to the routes"), errorCode: 500 });
                            this._routes.listen(this._app);
                        }
                        ;
                        if (!this._isKafkaClientRequired) return [3 /*break*/, 8];
                        kafkaClient = foundation_1.KafkaClient.getInstance();
                        if (!this._clientId)
                            throw new errors_1.GenericValidationError({ error: new Error('_clientId is need to be set for kafka client connection'), errorCode: 500 });
                        if (!this._brokers)
                            throw new errors_1.GenericValidationError({ error: new Error('_brokers is need to be set for kafka client connection'), errorCode: 500 });
                        if (kafkaClient.isConsumerReq && !this._consumerConfig)
                            throw new errors_1.GenericValidationError({ error: new Error('_consumerConfig is need to be set for kafka client connection'), errorCode: 500 });
                        if (kafkaClient.isConsumerReq && !this._listeners)
                            throw new errors_1.GenericValidationError({ error: new Error('_listeners is need to be set for kafka client connection'), errorCode: 500 });
                        if (kafkaClient.isConsumerReq && !this._consumerRunConfig)
                            throw new errors_1.GenericValidationError({ error: new Error('_consumerRunConfig is need to be set for kafka client connection'), errorCode: 500 });
                        kafkaClient.clientId = this._clientId;
                        kafkaClient.brokers = this._brokers;
                        if (this._producerConfig)
                            kafkaClient.producerConfig = this._producerConfig;
                        if (this._consumerConfig)
                            kafkaClient.consumerConfig = this._consumerConfig;
                        if (this._listeners)
                            kafkaClient.listeners = this._listeners;
                        if (this._consumerRunConfig)
                            kafkaClient.consumerRunConfig = this._consumerRunConfig;
                        kafkaClient.init();
                        return [4 /*yield*/, kafkaClient.onConnect()];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, kafkaClient.onSubscribe()];
                    case 7:
                        _a.sent();
                        _a.label = 8;
                    case 8:
                        ;
                        // FCM Notification Required
                        if (this._isNotificationRequired) {
                            fcmConnect = foundation_1.FCMConnect.getInstance();
                            fcmConnect.setConfig();
                        }
                        ;
                        return [2 /*return*/, true];
                    case 9:
                        error_1 = _a.sent();
                        console.error('Error while starting up server :', error_1);
                        process.exit();
                        return [3 /*break*/, 10];
                    case 10:
                        ;
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    return Loader;
}(BaseLoader));
exports.Loader = Loader;
;
