import { Request, Response, NextFunction } from 'express';
import { Model } from "mongoose";
interface ChannelAccessMiddleware {
    _checkChannelAccess<ApprovedChanelType, RoleType>(request: Request, approvedChannel: Model<ApprovedChanelType>, role: Model<RoleType>, user: Record<string, any>): Promise<Record<string, any>>;
    checkChannelAccess<ApprovedChanelType, RoleType>(approvedChannel: Model<ApprovedChanelType>, role: Model<RoleType>): (req: Request, res: Response, next: NextFunction) => {};
    _checkChannelAccessByChannelStaff<ApprovedChanelType, RoleType>(request: Request, approvedChannel: Model<ApprovedChanelType>, role: Model<RoleType>, user: Record<string, any>): Promise<Record<string, any>>;
    checkChannelAccessByChannelStaff<ApprovedChanelType, RoleType>(approvedChannel: Model<ApprovedChanelType>, role: Model<RoleType>): (req: Request, res: Response, next: NextFunction) => {};
}
declare class ChannelAccessMiddleware implements ChannelAccessMiddleware {
    private static _instance;
    private constructor();
    static getInstance(): ChannelAccessMiddleware;
}
export { ChannelAccessMiddleware };
