"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelAccessMiddleware = void 0;
var errors_1 = require("../errors");
var services_1 = require("../services");
var mongooseService = services_1.MongooseService.getInstance();
;
var ChannelAccessMiddleware = /** @class */ (function () {
    function ChannelAccessMiddleware() {
    }
    ;
    ChannelAccessMiddleware.getInstance = function () {
        if (!ChannelAccessMiddleware._instance)
            ChannelAccessMiddleware._instance = new ChannelAccessMiddleware();
        return ChannelAccessMiddleware._instance;
    };
    ;
    ChannelAccessMiddleware.prototype._checkChannelAccess = function (req, approvedChannel, role, user) {
        return __awaiter(this, void 0, void 0, function () {
            var _role, channelQuery, channel, channelObj, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        if (!user)
                            throw new errors_1.GenericValidationError({ error: new Error("checkChannelAccess middleware depends on auth middleware."), errorCode: 500 });
                        return [4 /*yield*/, mongooseService.find(role, {}, undefined, undefined, undefined, undefined, undefined, undefined, undefined, "value")];
                    case 1:
                        _role = _a.sent();
                        channelQuery = {
                            ownedBy: user.id
                        };
                        if (req.header('channel-id')) {
                            channelQuery._id = req.header('channel-id');
                        }
                        if (!_role.includes(user.role))
                            throw new errors_1.GenericValidationError({ error: new Error("You are using this middleware for some other type of users and not for the intended one."), errorCode: 500 });
                        return [4 /*yield*/, mongooseService.find(approvedChannel, channelQuery)];
                    case 2:
                        channel = _a.sent();
                        channelObj = approvedChannel.jsonObj(channel);
                        if (channelObj.length === 0) {
                            throw new errors_1.GenericValidationError({ error: new Error("You don't have access to make this request."), errorCode: 403 });
                        }
                        ;
                        return [2 /*return*/, {}];
                    case 3:
                        error_1 = _a.sent();
                        throw error_1;
                    case 4:
                        ;
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    ChannelAccessMiddleware.prototype.checkChannelAccess = function (approvedChannel, role) {
        var _this = this;
        return function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
            var user, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        user = res.locals.user;
                        return [4 /*yield*/, this._checkChannelAccess(req, approvedChannel, role, user)];
                    case 1:
                        _a.sent();
                        next();
                        return [3 /*break*/, 3];
                    case 2:
                        error_2 = _a.sent();
                        return [2 /*return*/, next(error_2)];
                    case 3:
                        ;
                        return [2 /*return*/];
                }
            });
        }); };
    };
    ;
    ChannelAccessMiddleware.prototype._checkChannelAccessByChannelStaff = function (req, approvedChannel, role, user) {
        return __awaiter(this, void 0, void 0, function () {
            var _role, channelQuery, channel, channelObj, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        if (!user)
                            throw new errors_1.GenericValidationError({ error: new Error("checkChannelAccessByChannelStaff middleware depends on auth middleware."), errorCode: 500 });
                        if (!user.approvedChannelId)
                            throw new errors_1.GenericValidationError({ error: new Error("approvedChannelId is required for checkChannelAccessByChannelStaff middleware."), errorCode: 500 });
                        return [4 /*yield*/, mongooseService.find(role, {}, undefined, undefined, undefined, undefined, undefined, undefined, undefined, "value")];
                    case 1:
                        _role = _a.sent();
                        channelQuery = {};
                        // if (req.header('channel-id')) {
                        //     if(!user.approvedChannelIds.some((ele: any) => ele.toString() === req.header('channel-id'))) throw new GenericValidationError({error: new Error(`You don't have access to the requested channel.`), errorCode: 400});
                        //     channelQuery._id = { $in: user.approvedChannelIds };
                        // };
                        console.log("req.header('channel-id') :: user.approvedChannelId ::", req.header('channel-id'), user.approvedChannelId);
                        if (req.header('channel-id')) {
                            if (user.approvedChannelId.toString() !== req.header('channel-id'))
                                throw new errors_1.GenericValidationError({ error: new Error("You don't have access to the requested channel."), errorCode: 400 });
                            channelQuery._id = { $eq: user.approvedChannelId };
                        }
                        ;
                        if (!_role.includes(user.role))
                            throw new errors_1.GenericValidationError({ error: new Error("You are using this middleware for some other users and not for the intended one."), errorCode: 500 });
                        return [4 /*yield*/, mongooseService.findOne(approvedChannel, channelQuery)];
                    case 2:
                        channel = _a.sent();
                        channelObj = approvedChannel.jsonObj(channel);
                        console.log("channelObj :::", channelObj);
                        if (!channelObj)
                            throw new errors_1.GenericValidationError({ error: new Error("You don't have access to make this request."), errorCode: 403 });
                        return [2 /*return*/, {}];
                    case 3:
                        error_3 = _a.sent();
                        console.log("_checkChannelAccessByChannelStaff :: error ::", error_3);
                        throw error_3;
                    case 4:
                        ;
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    ChannelAccessMiddleware.prototype.checkChannelAccessByChannelStaff = function (approvedChannel, role) {
        var _this = this;
        return function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
            var user, error_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        user = res.locals.user;
                        return [4 /*yield*/, this._checkChannelAccessByChannelStaff(req, approvedChannel, role, user)];
                    case 1:
                        _a.sent();
                        next();
                        return [3 /*break*/, 3];
                    case 2:
                        error_4 = _a.sent();
                        return [2 /*return*/, next(error_4)];
                    case 3:
                        ;
                        return [2 /*return*/];
                }
            });
        }); };
    };
    ;
    return ChannelAccessMiddleware;
}());
exports.ChannelAccessMiddleware = ChannelAccessMiddleware;
