interface RequestConfig {
    baseURL?: string;
    data?: Record<string, any>;
    headers?: Record<string, string | number | boolean>;
    params?: Record<string, string | number | boolean>;
}
interface ResponseConfig {
    status: number;
    data: any;
    headers?: Record<string, string | number | boolean>;
}
interface BaseHttpService {
    get(url: string, config: RequestConfig): Promise<ResponseConfig>;
    post(url: string, body?: Record<string, any>, config?: RequestConfig): Promise<ResponseConfig>;
    patch(url: string, body?: Record<string, any>, config?: RequestConfig): Promise<ResponseConfig>;
    delete(url: string, config?: RequestConfig): Promise<ResponseConfig>;
    head(url: string, config?: RequestConfig): Promise<ResponseConfig>;
    options(url: string, config?: RequestConfig): Promise<ResponseConfig>;
}
declare class HttpService implements BaseHttpService {
    private _defaultConfig?;
    constructor(requestConfig?: RequestConfig);
    get(url: string, config?: RequestConfig): Promise<ResponseConfig>;
    post(url: string, body?: Record<string, any>, config?: RequestConfig): Promise<ResponseConfig>;
    patch(url: string, body?: Record<string, any>, config?: RequestConfig): Promise<ResponseConfig>;
    delete(url: string, config?: RequestConfig): Promise<ResponseConfig>;
    head(url: string, config?: RequestConfig): Promise<ResponseConfig>;
    options(url: string, config?: RequestConfig): Promise<ResponseConfig>;
}
export { BaseHttpService, HttpService, };
