"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MongooseService = void 0;
var mongoose_1 = __importDefault(require("mongoose"));
var foundation_1 = require("../foundation");
;
var MongooseService = /** @class */ (function () {
    function MongooseService() {
    }
    ;
    MongooseService.getInstance = function () {
        if (!MongooseService._instance)
            MongooseService._instance = new MongooseService();
        return MongooseService._instance;
    };
    ;
    MongooseService.prototype._reconnectIfDisconnected = function () {
        return __awaiter(this, void 0, void 0, function () {
            var mongooseConnect, dbConnectionString;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mongooseConnect = foundation_1.MongooseConnect.getInstance();
                        dbConnectionString = mongooseConnect.dbConnectionString;
                        if (!(mongoose_1.default.connection.readyState !== 1)) return [3 /*break*/, 2];
                        return [4 /*yield*/, mongoose_1.default.connect(dbConnectionString)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    ;
    /**
     * Get a mongoose document by id
     * @param collRef
     * @param id
     * @param projection
     * @param options
     * @param session
     * @returns
     */
    MongooseService.prototype.findById = function (collRef, id, projection, options, session) {
        return __awaiter(this, void 0, void 0, function () {
            var _query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        _query = collRef.findById(id, projection, options);
                        if (session)
                            _query.session(session);
                        return [4 /*yield*/, _query];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    /**
     * Get a mongoose document for the requested filter query
     * @param collRef
     * @param query
     * @param projection
     * @param options
     * @param session
     * @returns
     */
    MongooseService.prototype.findOne = function (collRef, query, projection, options, session) {
        return __awaiter(this, void 0, void 0, function () {
            var _query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        _query = collRef.findOne(query, projection, options);
                        if (session)
                            _query.session(session);
                        return [4 /*yield*/, _query];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    /**
     * Get all matched mongoose documents for the requested filter query
     * @param collRef
     * @param query
     * @param projection
     * @param options
     * @param sort
     * @param skip
     * @param limit
     * @param session
     * @returns
     */
    MongooseService.prototype.find = function (collRef, query, projection, options, sort, skip, limit, session, collationOptions, distinct) {
        return __awaiter(this, void 0, void 0, function () {
            var _query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        _query = collRef.find(query, projection, options);
                        if (sort)
                            _query.sort(sort);
                        if (skip)
                            _query.skip(skip);
                        if (limit)
                            _query.limit(limit);
                        if (collationOptions)
                            _query.collation(collationOptions);
                        if (session)
                            _query.session(session);
                        if (distinct)
                            _query.distinct(distinct);
                        return [4 /*yield*/, _query];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    /**
     * Saving a mongoose document
     * @param docRef
     * @param options
     * @returns
     */
    MongooseService.prototype.save = function (docRef, options) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, docRef.save(options)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    /**
     * Finding a document by an id and updating its info.
     * @param collRef
     * @param id
     * @param updateQuery
     * @param options
     * @param session
     * @returns
     */
    MongooseService.prototype.findByIdAndUpdate = function (collRef, id, updateQuery, options, session) {
        return __awaiter(this, void 0, void 0, function () {
            var _query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        _query = collRef.findByIdAndUpdate(id, updateQuery, options);
                        if (session)
                            _query.session(session);
                        return [4 /*yield*/, _query];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    /**
     * Finding a document by some key and updating its info.
     * @param collRef
     * @param query
     * @param updateQuery
     * @param options
     * @param session
     * @returns
     */
    MongooseService.prototype.findOneAndUpdate = function (collRef, query, updateQuery, options, session) {
        return __awaiter(this, void 0, void 0, function () {
            var _query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        _query = collRef.findOneAndUpdate(query, updateQuery, options);
                        if (session)
                            _query.session(session);
                        return [4 /*yield*/, _query];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    /**
     * Updating a document of a collection.
     * @param collRef
     * @param query
     * @param updateQuery
     * @param options
     * @param session
     * @returns
     */
    MongooseService.prototype.updateOne = function (collRef, query, updateQuery, options, session) {
        return __awaiter(this, void 0, void 0, function () {
            var _query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        _query = collRef.updateOne(query, updateQuery, options);
                        if (session)
                            _query.session(session);
                        return [4 /*yield*/, _query];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    /**
     * Updating many documents of a collection.
     * @param collRef
     * @param query
     * @param updateQuery
     * @param options
     * @param session
     * @returns
     */
    MongooseService.prototype.updateMany = function (collRef, query, updateQuery, options, session) {
        return __awaiter(this, void 0, void 0, function () {
            var _query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        _query = collRef.updateMany(query, updateQuery, options);
                        if (session)
                            _query.session(session);
                        return [4 /*yield*/, _query];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    /**
     * Mongoose aggregation queries
     * @param collRef
     * @param pipeline
     * @param options
     * @returns
     */
    MongooseService.prototype.aggregate = function (collRef, pipeline, options, session, ignoreSoftDelete) {
        return __awaiter(this, void 0, void 0, function () {
            var _query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        _query = collRef.aggregate(pipeline, options);
                        if (ignoreSoftDelete)
                            _query.option({ ignoreSoftDelete: true });
                        if (session)
                            _query.session(session);
                        return [4 /*yield*/, _query];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    /**
     * Counts the number of documents that matches the query
     * @param collRef
     * @param query
     * @param options
     * @param session
     * @returns
     */
    MongooseService.prototype.countDocuments = function (collRef, query, options, session) {
        return __awaiter(this, void 0, void 0, function () {
            var _query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        _query = collRef.countDocuments(query, options);
                        if (session)
                            _query.session(session);
                        return [4 /*yield*/, _query];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    MongooseService.prototype.insertMany = function (collRef, docs, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        _query = collRef.insertMany(docs, options);
                        return [4 /*yield*/, _query];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    MongooseService.prototype.findOneAndDelete = function (collRef, query, options, session) {
        return __awaiter(this, void 0, void 0, function () {
            var _query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._reconnectIfDisconnected()];
                    case 1:
                        _a.sent();
                        _query = collRef.findOneAndDelete(query, options);
                        if (session)
                            _query.session(session);
                        return [4 /*yield*/, _query];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    return MongooseService;
}());
exports.MongooseService = MongooseService;
;
