import mongoose, { CallbackError } from 'mongoose';
export declare abstract class BaseMongooseSchemaService {
    abstract get transform(): (doc: any, ret: any) => any;
    abstract transformData(): {
        toJSON: {
            transform: (doc: any, ret: any) => any;
        };
        timestamps: {
            createdAt: string;
            updatedAt: string;
        };
    };
    abstract genDocId(): mongoose.Types.ObjectId;
    abstract createdByAndUpdatedBySave(this: mongoose.Query<any, any, {}, any>, next: (err: CallbackError | undefined) => void): void;
    abstract createdByAndUpdatedByUpdate(this: mongoose.Query<any, any, {}, any>, next: (err: CallbackError | undefined) => void): void;
    abstract initialVersion(this: mongoose.Document<any, any, any>, next: (err: CallbackError | undefined) => void): void;
    abstract versionUpdate(this: mongoose.Query<any, any, {}, any>, next: (err: CallbackError | undefined) => void): void;
    abstract excludeDeleteMiddleware(this: mongoose.Query<any, any, {}, any>, next: (err: CallbackError | undefined) => void): void;
    abstract excludeDeleteAggregateMiddleware(this: mongoose.Aggregate<any>, next: (err: CallbackError | undefined) => void): void;
}
export declare class MongooseSchemaService extends BaseMongooseSchemaService {
    private static _instance;
    private _transform;
    private constructor();
    static getInstance(): MongooseSchemaService;
    get transform(): (doc: any, ret: any) => any;
    transformData(): {
        toJSON: {
            transform: (doc: any, ret: any) => any;
        };
        timestamps: {
            createdAt: string;
            updatedAt: string;
        };
    };
    genDocId(): mongoose.Types.ObjectId;
    createdByAndUpdatedBySave(this: mongoose.Query<any, any, {}, any>, next: (err: CallbackError | undefined) => void): void;
    createdByAndUpdatedByUpdate(this: mongoose.Query<any, any, {}, any>, next: (err: CallbackError | undefined) => void): void;
    initialVersion(this: mongoose.Document<any, any, any>, next: (err: CallbackError | undefined) => void): void;
    versionUpdate(this: mongoose.Query<any, any, {}, any>, next: (err: CallbackError | undefined) => void): void;
    excludeDeleteMiddleware(this: mongoose.Query<any, any, {}, any>, next: (err: CallbackError | undefined) => void): void;
    excludeDeleteAggregateMiddleware(this: any, next: (err: CallbackError | undefined) => void): void;
}
