"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MongooseSchemaService = exports.BaseMongooseSchemaService = void 0;
var mongoose_1 = __importDefault(require("mongoose"));
var __1 = require("../");
var BaseMongooseSchemaService = /** @class */ (function () {
    function BaseMongooseSchemaService() {
    }
    return BaseMongooseSchemaService;
}());
exports.BaseMongooseSchemaService = BaseMongooseSchemaService;
;
var MongooseSchemaService = /** @class */ (function (_super) {
    __extends(MongooseSchemaService, _super);
    function MongooseSchemaService() {
        var _this = _super.call(this) || this;
        _this._transform = function (doc, ret) {
            var id = doc._id;
            ret.id = id;
            delete ret._id;
            delete ret.__v;
            return ret;
        };
        return _this;
    }
    ;
    MongooseSchemaService.getInstance = function () {
        if (!MongooseSchemaService._instance)
            MongooseSchemaService._instance = new MongooseSchemaService();
        return MongooseSchemaService._instance;
    };
    ;
    Object.defineProperty(MongooseSchemaService.prototype, "transform", {
        get: function () {
            return this._transform;
        },
        enumerable: false,
        configurable: true
    });
    ;
    MongooseSchemaService.prototype.transformData = function () {
        return {
            toJSON: {
                transform: this._transform,
            },
            timestamps: {
                createdAt: 'creationDate',
                updatedAt: 'lastModifiedDate',
            }
        };
    };
    ;
    MongooseSchemaService.prototype.genDocId = function () {
        return new mongoose_1.default.Types.ObjectId();
    };
    ;
    MongooseSchemaService.prototype.createdByAndUpdatedBySave = function (next) {
        var locals = this.get('locals');
        var excludeLocals = this.get('excludeLocals');
        console.log("excludeLocals and locals in createdByAndUpdatedByUpdate ::", excludeLocals, locals);
        if (excludeLocals)
            return next(undefined);
        if (!locals)
            throw new __1.GenericValidationError({ error: new Error("locals is required field for createdByAndUpdatedBySave mongoose middleware fn"), errorCode: 500 });
        if (!locals.user.id)
            throw new __1.GenericValidationError({ error: new Error("locals.user.id doesn't exist in createdByAndUpdatedBySave mongoose middleware fn"), errorCode: 500 });
        this.set('createdBy', locals.user.id);
        this.set('updatedBy', locals.user.id);
        next(undefined);
    };
    ;
    MongooseSchemaService.prototype.createdByAndUpdatedByUpdate = function (next) {
        var locals = this.get('locals');
        var excludeLocals = this.get('excludeLocals');
        console.log("excludeLocals and locals in createdByAndUpdatedByUpdate ::", excludeLocals, locals);
        if (excludeLocals)
            return next(undefined);
        if (!locals)
            throw new __1.GenericValidationError({ error: new Error("locals is required field for createdByAndUpdatedByUpdate mongoose middleware fn"), errorCode: 500 });
        if (!locals.user.id)
            throw new __1.GenericValidationError({ error: new Error("locals.user.id doesn't exist in createdByAndUpdatedByUpdate mongoose middleware fn"), errorCode: 500 });
        //! Try handling if upsert query is passed.
        this.set('updatedBy', locals.user.id);
        next(undefined);
    };
    ;
    MongooseSchemaService.prototype.initialVersion = function (next) {
        console.log("version in initialVersion :", this.get('__v'));
        if (!(this.get('__v') || this.get('__v') === 0)) {
            this.increment();
        }
        ;
        next(undefined);
    };
    ;
    MongooseSchemaService.prototype.versionUpdate = function (next) {
        console.log("version in versionUpdate ::", this.get('__v'));
        if (!(this.get('__v') || this.get('__v') === 0) && !this.getOptions().upsert) {
            this.update({}, { $inc: { __v: 1 } });
        }
        ;
        next(undefined);
    };
    ;
    MongooseSchemaService.prototype.excludeDeleteMiddleware = function (next) {
        var _a;
        try {
            if (!(JSON.stringify(this.getQuery().$or) ===
                JSON.stringify([{ isDeleted: true }, { isDeleted: false }])) &&
                !this.getQuery().isDeleted
                &&
                    !((_a = this.getQuery().$and) === null || _a === void 0 ? void 0 : _a.some(function (ele) { return (Object(ele).hasOwnProperty("isDeleted")) || (JSON.stringify(ele.$or) === JSON.stringify([{ isDeleted: true }, { isDeleted: false }])); }))) {
                this.where({ isDeleted: false });
            }
            ;
            next(undefined);
        }
        catch (error) {
            next(new Error("Error in excludeDeleteMiddleware fn, please contact support team to resolve this issue."));
        }
    };
    ;
    MongooseSchemaService.prototype.excludeDeleteAggregateMiddleware = function (next) {
        try {
            // Get the current aggregation pipeline and prepend a `$match` that excludes all soft-deleted docs
            var options = this.options;
            if (options["ignoreSoftDelete"]) {
                return next(undefined);
            }
            this.pipeline().unshift({ $match: { isDeleted: false } });
            next(undefined);
        }
        catch (error) {
            next(new Error("Error in excludeDeleteAggregateMiddleware fn, please contact support team to resolve this issue."));
        }
        ;
    };
    ;
    return MongooseSchemaService;
}(BaseMongooseSchemaService));
exports.MongooseSchemaService = MongooseSchemaService;
;
