import { FCMMessage, NotificationPayload, NotificationTypes } from "../interfaces";
interface BaseFCMService {
    getDeepLink(type: NotificationTypes, baseURL: string, payload: NotificationPayload): string;
    sendPushNotification(message: FCMMessage, type: NotificationTypes, token: string, payload: NotificationPayload, imageUrl: string, icon?: string, link?: string, clickAction?: string): Promise<void>;
}
declare class FCMService implements BaseFCMService {
    private static _instance;
    private _fcm;
    private constructor();
    static getInstance(): BaseFCMService;
    getDeepLink(type: NotificationTypes, baseURL: string, payload: NotificationPayload & {
        id: string;
    }): string;
    sendPushNotification(message: FCMMessage, type: NotificationTypes, token: string, payload: NotificationPayload, imageUrl: string, icon?: string, link?: string, clickAction?: string): Promise<void>;
}
export { BaseFCMService, FCMService };
