"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FCMService = void 0;
var foundation_1 = require("../foundation");
var interfaces_1 = require("../interfaces");
var errors_1 = require("../errors");
var fcmConnect = foundation_1.FCMConnect.getInstance();
;
var FCMService = /** @class */ (function () {
    function FCMService() {
        this._fcm = fcmConnect.fcm;
    }
    ;
    FCMService.getInstance = function () {
        if (!FCMService._instance)
            FCMService._instance = new FCMService();
        return FCMService._instance;
    };
    ;
    FCMService.prototype.getDeepLink = function (type, baseURL, payload) {
        var deepLink = "".concat(baseURL);
        switch (type) {
            case interfaces_1.NotificationTypes.WELCOME:
                {
                    deepLink += "/";
                    break;
                }
                ;
            case interfaces_1.NotificationTypes.BOOKING_CONFIRM:
                {
                    deepLink += "/events/my-bookings";
                    break;
                }
                ;
            case interfaces_1.NotificationTypes.BOOKING_CANCEL:
                {
                    deepLink += "/";
                    break;
                }
                ;
            case interfaces_1.NotificationTypes.EVENT_REMINDER:
                {
                    deepLink += "/view-event/".concat(payload.id);
                    break;
                }
                ;
            case interfaces_1.NotificationTypes.HOST_EVENT_CANCEL:
                {
                    deepLink += "/";
                    break;
                }
                ;
            case interfaces_1.NotificationTypes.CHANNEL_APPLICATION:
                {
                    deepLink += "/";
                    break;
                }
                ;
            case interfaces_1.NotificationTypes.CHANNEL_REVIEW:
                {
                    deepLink += "/channel/".concat(payload.id);
                    break;
                }
                ;
            case interfaces_1.NotificationTypes.CHANNEL_CONFIRMATION:
                {
                    deepLink += "/channel/".concat(payload.id);
                    break;
                }
                ;
            case interfaces_1.NotificationTypes.CHANNEL_REJECTION:
                {
                    deepLink += "/channel/".concat(payload.id);
                    break;
                }
                ;
            case interfaces_1.NotificationTypes.CHANNEL_DELETION:
                {
                    deepLink += "/";
                    break;
                }
                ;
            case interfaces_1.NotificationTypes.FRIEND_REQUEST:
                {
                    deepLink += "/profile/friends";
                    break;
                }
                ;
            case interfaces_1.NotificationTypes.FRIEND_REQUEST_ACCEPTED:
                {
                    deepLink += "/profile/friends";
                    break;
                }
                ;
            default:
                {
                    throw new errors_1.GenericValidationError({ error: new Error("Invalid notification type"), errorCode: 500 });
                }
                ;
        }
        ;
        return deepLink;
    };
    ;
    FCMService.prototype.sendPushNotification = function (message, type, token, payload, imageUrl, icon, link, clickAction) {
        return __awaiter(this, void 0, void 0, function () {
            var payloadJSON, _message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        payloadJSON = JSON.parse(JSON.stringify(payload));
                        console.log("payloadJSON :::", payloadJSON);
                        _message = {
                            token: token,
                            notification: {
                                title: message.title,
                                body: message.body,
                                imageUrl: imageUrl
                            },
                            data: __assign({ type: type }, payloadJSON),
                            webpush: {
                                fcmOptions: {
                                    link: link
                                }
                            },
                            android: {
                                notification: {
                                    clickAction: clickAction,
                                }
                            },
                            apns: {
                                fcmOptions: {
                                    imageUrl: imageUrl
                                }
                            }
                        };
                        return [4 /*yield*/, this._fcm.messaging().send(_message)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    return FCMService;
}());
exports.FCMService = FCMService;
;
