import { ClientSession, FilterQuery, Model, PipelineStage } from "mongoose";
import { SimplePaginatorOptions, PaginatorOptions } from '../interfaces';
import { CollationOptions } from 'mongodb';
export interface BasePaginatorService {
    simpleFind<DocType>(collRef: Model<DocType>, query: FilterQuery<DocType>, options: SimplePaginatorOptions, session?: ClientSession, projection?: any, collationOptions?: CollationOptions): Promise<{
        docs: DocType[];
        count: number;
    }>;
    simpleAggregate<DocType>(collRef: Model<DocType>, query: PipelineStage[], options: SimplePaginatorOptions, session?: ClientSession, ignoreSoftDelete?: boolean): Promise<{
        docs: any[];
        count: number;
    }>;
    find<DocType>(collRef: Model<DocType>, query: FilterQuery<DocType>[], options: PaginatorOptions, session?: ClientSession, projection?: any): Promise<{
        docs: DocType[];
        count: number;
    }>;
    aggregate<DocType>(collRef: Model<DocType>, query: PipelineStage[], options: PaginatorOptions, session?: ClientSession): Promise<{
        docs: any[];
        count: number;
    }>;
}
export declare class PaginatorService implements BasePaginatorService {
    private static _instance;
    private constructor();
    static getInstance(): PaginatorService;
    simpleFind<DocType>(collRef: Model<DocType>, query: FilterQuery<DocType>, options: SimplePaginatorOptions, session?: ClientSession, projection?: any, collationOptions?: CollationOptions): Promise<{
        docs: DocType[];
        count: number;
    }>;
    simpleAggregate<DocType>(collRef: Model<DocType>, query: PipelineStage[], options: SimplePaginatorOptions, session?: ClientSession, ignoreSoftDelete?: boolean): Promise<{
        docs: any[];
        count: number;
    }>;
    find<DocType>(collRef: Model<DocType>, query: FilterQuery<DocType>[], options: PaginatorOptions, session?: ClientSession, projection?: any): Promise<{
        docs: DocType[];
        count: number;
    }>;
    aggregate<DocType>(collRef: Model<DocType>, query: PipelineStage[], options: PaginatorOptions, session?: ClientSession): Promise<{
        docs: any[];
        count: number;
    }>;
}
