"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaginatorService = void 0;
var mongoose_1 = __importDefault(require("mongoose"));
var _1 = require("./");
var interfaces_1 = require("../interfaces");
var mongooseService = _1.MongooseService.getInstance();
;
var PaginatorService = /** @class */ (function () {
    function PaginatorService() {
    }
    ;
    PaginatorService.getInstance = function () {
        if (!PaginatorService._instance)
            PaginatorService._instance = new PaginatorService();
        return PaginatorService._instance;
    };
    ;
    PaginatorService.prototype.simpleFind = function (collRef, query, options, session, projection, collationOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var sort, skipCount, docs, count;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        sort = {}, skipCount = options.pageIndex > 0 ? options.pageIndex * options.pageSize : 0;
                        if (options.sortType === interfaces_1.SortTypes.ASC)
                            sort[options.sortField] = 1;
                        else
                            sort[options.sortField] = -1;
                        return [4 /*yield*/, mongooseService.find(collRef, query, projection, undefined, sort, skipCount, options.pageSize, session, collationOptions)];
                    case 1:
                        docs = _a.sent();
                        return [4 /*yield*/, mongooseService.countDocuments(collRef, query, undefined, session)];
                    case 2:
                        count = _a.sent();
                        return [2 /*return*/, { docs: docs, count: count }];
                }
            });
        });
    };
    ;
    PaginatorService.prototype.simpleAggregate = function (collRef, query, options, session, ignoreSoftDelete) {
        return __awaiter(this, void 0, void 0, function () {
            var sort, skipCount, docsSnapshotQuery, projectionQuery, pipelineQuery, documentSnapshots, docs, count;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        sort = { $sort: {} }, skipCount = options.pageIndex > 0 ? options.pageIndex * options.pageSize : 0;
                        if (options.sortType === interfaces_1.SortTypes.ASC)
                            sort['$sort'][options.sortField] = 1;
                        else
                            sort['$sort'][options.sortField] = -1;
                        docsSnapshotQuery = [];
                        if (options.pageSize)
                            docsSnapshotQuery.push({ $skip: skipCount }, { $limit: options.pageSize });
                        projectionQuery = [];
                        if (query.length && (query[query.length - 1]).$project)
                            projectionQuery = query.splice(query.length - 1, 1);
                        pipelineQuery = __spreadArray(__spreadArray(__spreadArray(__spreadArray([], query, true), [
                            __assign({}, sort)
                        ], false), projectionQuery, true), [
                            {
                                $facet: {
                                    docs: __spreadArray(__spreadArray([], docsSnapshotQuery, true), [
                                        { $group: { _id: null, docsArr: { $push: '$$ROOT' } } },
                                    ], false),
                                    count: [{ $group: { _id: null, count: { $sum: 1 } } }],
                                }
                            },
                            {
                                $project: {
                                    docs: {
                                        $ifNull: [
                                            {
                                                $arrayElemAt: ['$docs.docsArr', 0],
                                            },
                                            [],
                                        ],
                                    },
                                    count: { $ifNull: [{ $arrayElemAt: ['$count.count', 0] }, 0] },
                                }
                            },
                        ], false);
                        return [4 /*yield*/, mongooseService.aggregate(collRef, pipelineQuery, undefined, session, ignoreSoftDelete)];
                    case 1:
                        documentSnapshots = _a.sent();
                        docs = documentSnapshots[0].docs;
                        count = documentSnapshots[0].count;
                        return [2 /*return*/, { docs: docs, count: count }];
                }
            });
        });
    };
    ;
    PaginatorService.prototype.find = function (collRef, query, options, session, projection) {
        return __awaiter(this, void 0, void 0, function () {
            var sort, inputQuery, sortFieldObj, indexName, operator, _matchQuery, _matchQueryObj, finalQuery, docs, countFinalQuery, count;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        sort = {}, inputQuery = [];
                        if (options.type === interfaces_1.PaginatorTypes.FORWARD) {
                            if (options.sortType === interfaces_1.SortTypes.ASC) {
                                if (options.sortField !== '_id') {
                                    sort[options.sortField] = 1;
                                    sort['_id'] = 1;
                                }
                                else
                                    sort['_id'] = 1;
                            }
                            else {
                                if (options.sortField !== '_id') {
                                    sort[options.sortField] = -1;
                                    sort['_id'] = -1;
                                }
                                else
                                    sort['_id'] = -1;
                            }
                            ;
                        }
                        else {
                            if (options.sortType === interfaces_1.SortTypes.ASC) {
                                if (options.sortField !== '_id') {
                                    sort[options.sortField] = -1;
                                    sort['_id'] = -1;
                                }
                                else
                                    sort['_id'] = -1;
                            }
                            else {
                                if (options.sortField !== '_id') {
                                    sort[options.sortField] = 1;
                                    sort['_id'] = 1;
                                }
                                else
                                    sort['_id'] = 1;
                            }
                            ;
                        }
                        ;
                        if (options.sortField &&
                            options.sortFieldValue &&
                            options.sortFieldValue !== 'undefined' &&
                            options.sortFieldValue !== 'null') {
                            sortFieldObj = {};
                            sortFieldObj[options.sortField] = { $eq: options.sortFieldValue };
                            inputQuery.push({ $or: [{ $and: [sortFieldObj] }] });
                        }
                        ;
                        if (options.type === interfaces_1.PaginatorTypes.FORWARD) {
                            indexName = "endIndex";
                            if (options.sortType === interfaces_1.SortTypes.ASC)
                                operator = "$gt";
                            else
                                operator = "$lt";
                        }
                        else {
                            indexName = "startIndex";
                            if (options.sortType === interfaces_1.SortTypes.ASC)
                                operator = "$lt";
                            else
                                operator = "$gt";
                        }
                        ;
                        if (options.startIndex || options.endIndex) {
                            _matchQuery = { _id: {} };
                            _matchQuery._id[operator] = new mongoose_1.default.Types.ObjectId(options[indexName]);
                            if (options.sortField &&
                                options.sortFieldValue &&
                                options.sortFieldValue !== 'undefined' &&
                                options.sortFieldValue !== 'null') {
                                _matchQueryObj = {};
                                _matchQueryObj[options['sortField']] = {};
                                _matchQueryObj[options['sortField']][operator] = options.sortFieldValue;
                                inputQuery[0].$or.unshift(_matchQueryObj);
                                inputQuery[0].$or[1].$and.push(_matchQuery);
                            }
                            else
                                inputQuery.push(_matchQuery);
                        }
                        ;
                        finalQuery = {};
                        if (__spreadArray(__spreadArray([], inputQuery, true), query, true).length)
                            finalQuery = { $and: __spreadArray(__spreadArray([], inputQuery, true), query, true) };
                        return [4 /*yield*/, mongooseService.find(collRef, finalQuery, projection, undefined, sort, undefined, options.pageSize, session)];
                    case 1:
                        docs = _a.sent();
                        if (options.type === interfaces_1.PaginatorTypes.BACKWARD)
                            docs.reverse();
                        countFinalQuery = {};
                        if (query.length)
                            countFinalQuery = { $and: __spreadArray([], query, true) };
                        return [4 /*yield*/, mongooseService.countDocuments(collRef, countFinalQuery, undefined, session)];
                    case 2:
                        count = _a.sent();
                        return [2 /*return*/, { docs: docs, count: count }];
                }
            });
        });
    };
    ;
    PaginatorService.prototype.aggregate = function (collRef, query, options, session) {
        return __awaiter(this, void 0, void 0, function () {
            var sort, inputQuery, indexName, operator, _matchQuery, _matchQueryObj, pipelineQuery, docsSnapshotQuery, documentSnapshots, docs, count;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        sort = { $sort: {} }, inputQuery = [];
                        if (options.type === interfaces_1.PaginatorTypes.FORWARD) {
                            if (options.sortType === interfaces_1.SortTypes.ASC) {
                                if (options.sortField !== '_id') {
                                    sort['$sort'][options.sortField] = 1;
                                    sort['$sort']['_id'] = 1;
                                }
                                else
                                    sort['$sort']['_id'] = 1;
                            }
                            else {
                                if (options.sortField !== '_id') {
                                    sort['$sort'][options.sortField] = -1;
                                    sort['$sort']['_id'] = -1;
                                }
                                else
                                    sort['$sort']['_id'] = -1;
                            }
                            ;
                        }
                        else {
                            if (options.sortType === interfaces_1.SortTypes.ASC) {
                                if (options.sortField !== '_id') {
                                    sort['$sort'][options.sortField] = -1;
                                    sort['$sort']['_id'] = -1;
                                }
                                else
                                    sort['$sort']['_id'] = -1;
                            }
                            else {
                                if (options.sortField !== '_id') {
                                    sort['$sort'][options.sortField] = 1;
                                    sort['$sort']['_id'] = 1;
                                }
                                else
                                    sort['$sort']['_id'] = 1;
                            }
                            ;
                        }
                        ;
                        if (options.sortField &&
                            options.sortFieldValue &&
                            options.sortFieldValue !== 'undefined' &&
                            options.sortFieldValue !== 'null') {
                            inputQuery.push({
                                $or: [
                                    {
                                        $and: [
                                            { $eq: ["$".concat(options['sortField']), options.sortFieldValue] },
                                        ],
                                    },
                                ],
                            });
                        }
                        ;
                        if (options.type === interfaces_1.PaginatorTypes.FORWARD) {
                            indexName = "endIndex";
                            if (options.sortType === interfaces_1.SortTypes.ASC)
                                operator = "$gt";
                            else
                                operator = "$lt";
                        }
                        else {
                            indexName = "startIndex";
                            if (options.sortType === interfaces_1.SortTypes.ASC)
                                operator = "$lt";
                            else
                                operator = "$gt";
                        }
                        ;
                        if (options.startIndex || options.endIndex) {
                            _matchQuery = {};
                            _matchQuery[operator] = ['$_id', new mongoose_1.default.Types.ObjectId(options[indexName])];
                            if (options.sortField &&
                                options.sortFieldValue &&
                                options.sortFieldValue !== 'undefined' &&
                                options.sortFieldValue !== 'null') {
                                _matchQueryObj = {};
                                _matchQueryObj[operator] = ["$".concat(options['sortField']), options.sortFieldValue];
                                inputQuery[0].$or.unshift(_matchQueryObj);
                                inputQuery[0].$or[1].$and.push(_matchQuery);
                            }
                            else
                                inputQuery.push(_matchQuery);
                        }
                        ;
                        pipelineQuery = [];
                        docsSnapshotQuery = [];
                        if (options.pageSize)
                            docsSnapshotQuery.push({ $limit: options.pageSize });
                        pipelineQuery.push.apply(pipelineQuery, __spreadArray(__spreadArray([], query, false), [__assign({}, sort), {
                                $facet: {
                                    docs: __spreadArray(__spreadArray([
                                        { $match: { $expr: { $and: __spreadArray([], inputQuery, true) } } }
                                    ], docsSnapshotQuery, true), [
                                        { $group: { _id: null, docsArr: { $push: '$$ROOT' } } },
                                    ], false),
                                    count: [{ $group: { _id: null, count: { $sum: 1 } } }],
                                },
                            },
                            {
                                $project: {
                                    docs: {
                                        $ifNull: [
                                            {
                                                $arrayElemAt: ['$docs.docsArr', 0],
                                            },
                                            [],
                                        ],
                                    },
                                    count: { $ifNull: [{ $arrayElemAt: ['$count.count', 0] }, 0] },
                                },
                            }], false));
                        console.log("pipelineQuery :::", JSON.stringify(pipelineQuery));
                        return [4 /*yield*/, mongooseService.aggregate(collRef, pipelineQuery, undefined, session)];
                    case 1:
                        documentSnapshots = _a.sent();
                        if (options.type === interfaces_1.PaginatorTypes.BACKWARD)
                            documentSnapshots[0].docs.reverse();
                        docs = documentSnapshots[0].docs;
                        count = documentSnapshots[0].count;
                        return [2 /*return*/, { docs: docs, count: count }];
                }
            });
        });
    };
    ;
    return PaginatorService;
}());
exports.PaginatorService = PaginatorService;
;
