"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SSOService = void 0;
var __1 = require("..");
;
var SSOService = /** @class */ (function () {
    function SSOService() {
        this._ssoConnect = __1.SSOConnect.getInstance();
    }
    ;
    SSOService.getInstance = function () {
        if (!SSOService._instance)
            SSOService._instance = new SSOService();
        return SSOService._instance;
    };
    ;
    /**
     * Save the user data initially.
     * @param userData
     * @returns
     */
    SSOService.prototype.saveUser = function (userData) {
        return __awaiter(this, void 0, void 0, function () {
            var ssoClient, realmObj, keycloakUser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ssoClient = this._ssoConnect.adminClient;
                        realmObj = { realm: this._ssoConnect.ssoRealmName };
                        return [4 /*yield*/, ssoClient.users.create(__assign(__assign({}, realmObj), userData))];
                    case 1:
                        keycloakUser = _a.sent();
                        return [2 /*return*/, keycloakUser.id];
                }
            });
        });
    };
    ;
    /**
     * Get all the users that match the query
     * @param query
     * @returns
     */
    SSOService.prototype.findUser = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var ssoClient, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ssoClient = this._ssoConnect.adminClient;
                        return [4 /*yield*/, ssoClient.users.find(query)];
                    case 1:
                        user = _a.sent();
                        return [2 /*return*/, user];
                }
            });
        });
    };
    /**
     * Get the user by the sso id
     * @param ssoId
     * @returns
     */
    SSOService.prototype.findUserById = function (ssoId) {
        return __awaiter(this, void 0, void 0, function () {
            var ssoClient, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ssoClient = this._ssoConnect.adminClient;
                        return [4 /*yield*/, ssoClient.users.findOne({ id: ssoId })];
                    case 1:
                        user = _a.sent();
                        return [2 /*return*/, user];
                }
            });
        });
    };
    /**
     * Update the user based on the SSOId.
     * @param ssoId
     * @param query
     */
    SSOService.prototype.updateUser = function (ssoId, query) {
        return __awaiter(this, void 0, void 0, function () {
            var ssoClient, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ssoClient = this._ssoConnect.adminClient;
                        return [4 /*yield*/, ssoClient.users.update({ id: ssoId }, query)];
                    case 1:
                        user = _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Deleting the user based on id
     * @param ssoId - Unique user id from sso server
     */
    SSOService.prototype.deleteUser = function (ssoId) {
        return __awaiter(this, void 0, void 0, function () {
            var ssoClient, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ssoClient = this._ssoConnect.adminClient;
                        return [4 /*yield*/, ssoClient.users.del({ id: ssoId })];
                    case 1:
                        user = _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Add the client roles for user
     * @param roleInfo
     */
    SSOService.prototype.addUserRole = function (roleInfo) {
        return __awaiter(this, void 0, void 0, function () {
            var ssoClient, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ssoClient = this._ssoConnect.adminClient;
                        return [4 /*yield*/, ssoClient.users.addClientRoleMappings(roleInfo)];
                    case 1:
                        user = _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * List the client roles for user
     * @param roleInfo
     */
    SSOService.prototype.listUserRole = function (roleInfo) {
        return __awaiter(this, void 0, void 0, function () {
            var ssoClient, role;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ssoClient = this._ssoConnect.adminClient;
                        return [4 /*yield*/, ssoClient.users.listCompositeClientRoleMappings(roleInfo)];
                    case 1:
                        role = _a.sent();
                        return [2 /*return*/, role];
                }
            });
        });
    };
    /**
 * Delete the client roles for user
 * @param roleInfo
 */
    SSOService.prototype.deleteUserRole = function (roleInfo) {
        return __awaiter(this, void 0, void 0, function () {
            var ssoClient, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ssoClient = this._ssoConnect.adminClient;
                        return [4 /*yield*/, ssoClient.users.delClientRoleMappings(roleInfo)];
                    case 1:
                        user = _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    SSOService.prototype.logoutUser = function (ssoId) {
        return __awaiter(this, void 0, void 0, function () {
            var ssoClient;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ssoClient = this._ssoConnect.adminClient;
                        return [4 /*yield*/, ssoClient.users.logout({ id: ssoId })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    return SSOService;
}());
exports.SSOService = SSOService;
;
