"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StripeService = void 0;
var stripe_1 = __importDefault(require("stripe"));
var foundation_1 = require("../foundation");
var stripeConnect = foundation_1.StripeConnect.getInstance();
;
var StripeService = /** @class */ (function () {
    // private _nconf: NCONF;
    function StripeService() {
        // this._nconf = Nconf.getInstance().nconf;
        this._stripe = stripeConnect.stripe;
    }
    ;
    StripeService.getInstance = function () {
        if (!StripeService._instance)
            StripeService._instance = new StripeService();
        return StripeService._instance;
    };
    ;
    StripeService.prototype.createCustomer = function (sourceParams) {
        return __awaiter(this, void 0, void 0, function () {
            var customer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.create(sourceParams)];
                    case 1:
                        customer = _a.sent();
                        return [2 /*return*/, customer];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrieveCustomer = function (customerId) {
        return __awaiter(this, void 0, void 0, function () {
            var customer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.retrieve(customerId)];
                    case 1:
                        customer = _a.sent();
                        return [2 /*return*/, customer];
                }
            });
        });
    };
    ;
    StripeService.prototype.updateCustomer = function (customerId, updateParams) {
        return __awaiter(this, void 0, void 0, function () {
            var customer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.update(customerId, updateParams)];
                    case 1:
                        customer = _a.sent();
                        return [2 /*return*/, customer];
                }
            });
        });
    };
    ;
    StripeService.prototype.deleteCustomer = function (customerId) {
        return __awaiter(this, void 0, void 0, function () {
            var customer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.del(customerId)];
                    case 1:
                        customer = _a.sent();
                        return [2 /*return*/, customer];
                }
            });
        });
    };
    ;
    StripeService.prototype.listAllCustomers = function (limit, startingAfter) {
        return __awaiter(this, void 0, void 0, function () {
            var customers;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.list({
                            limit: limit,
                            starting_after: startingAfter
                        })];
                    case 1:
                        customers = _a.sent();
                        return [2 /*return*/, customers];
                }
            });
        });
    };
    ;
    StripeService.prototype.searchCustomers = function (query, limit, page) {
        return __awaiter(this, void 0, void 0, function () {
            var customers;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.search({
                            query: query,
                            limit: limit,
                            page: page
                        })];
                    case 1:
                        customers = _a.sent();
                        return [2 /*return*/, customers];
                }
            });
        });
    };
    ;
    StripeService.prototype.createCard = function (customerId, source) {
        return __awaiter(this, void 0, void 0, function () {
            var card;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.createSource(customerId, {
                            source: source
                        })];
                    case 1:
                        card = _a.sent();
                        return [2 /*return*/, card];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrieveCard = function (customerId, cardId) {
        return __awaiter(this, void 0, void 0, function () {
            var card;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.retrieveSource(customerId, cardId)];
                    case 1:
                        card = _a.sent();
                        return [2 /*return*/, card];
                }
            });
        });
    };
    ;
    StripeService.prototype.updateCard = function (customerId, cardId, sourceParams) {
        return __awaiter(this, void 0, void 0, function () {
            var card;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.updateSource(customerId, cardId, sourceParams)];
                    case 1:
                        card = _a.sent();
                        return [2 /*return*/, card];
                }
            });
        });
    };
    ;
    StripeService.prototype.deleteCard = function (customerId, cardId) {
        return __awaiter(this, void 0, void 0, function () {
            var card;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.deleteSource(customerId, cardId)];
                    case 1:
                        card = _a.sent();
                        return [2 /*return*/, card];
                }
            });
        });
    };
    ;
    StripeService.prototype.listAllCards = function (customerId, limit, startingAfter) {
        return __awaiter(this, void 0, void 0, function () {
            var cards;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.listSources(customerId, { object: 'card', limit: limit, starting_after: startingAfter })];
                    case 1:
                        cards = _a.sent();
                        return [2 /*return*/, cards];
                }
            });
        });
    };
    ;
    StripeService.prototype.createCharge = function (amount, currency, source, description) {
        return __awaiter(this, void 0, void 0, function () {
            var charge;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.charges.create({
                            amount: amount,
                            currency: currency,
                            source: source,
                            description: description
                        })];
                    case 1:
                        charge = _a.sent();
                        return [2 /*return*/, charge];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrieveCharge = function (chargeId) {
        return __awaiter(this, void 0, void 0, function () {
            var charge;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.charges.retrieve(chargeId)];
                    case 1:
                        charge = _a.sent();
                        return [2 /*return*/, charge];
                }
            });
        });
    };
    ;
    StripeService.prototype.updateCharge = function (chargeId, chargeParams) {
        return __awaiter(this, void 0, void 0, function () {
            var charge;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.charges.update(chargeId, chargeParams)];
                    case 1:
                        charge = _a.sent();
                        return [2 /*return*/, charge];
                }
            });
        });
    };
    ;
    StripeService.prototype.captureCharge = function (chargeId) {
        return __awaiter(this, void 0, void 0, function () {
            var charge;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.charges.capture(chargeId)];
                    case 1:
                        charge = _a.sent();
                        return [2 /*return*/, charge];
                }
            });
        });
    };
    ;
    StripeService.prototype.createRefund = function (chargeId, amount) {
        return __awaiter(this, void 0, void 0, function () {
            var refund;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.refunds.create({
                            charge: chargeId,
                            amount: amount
                        })];
                    case 1:
                        refund = _a.sent();
                        return [2 /*return*/, refund];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrieveRefund = function (refundId) {
        return __awaiter(this, void 0, void 0, function () {
            var refund;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.refunds.retrieve(refundId)];
                    case 1:
                        refund = _a.sent();
                        return [2 /*return*/, refund];
                }
            });
        });
    };
    ;
    StripeService.prototype.updateRefund = function (refundId, refundParams) {
        return __awaiter(this, void 0, void 0, function () {
            var refund;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.refunds.update(refundId, refundParams)];
                    case 1:
                        refund = _a.sent();
                        return [2 /*return*/, refund];
                }
            });
        });
    };
    ;
    StripeService.prototype.cancelRefund = function (refundId) {
        return __awaiter(this, void 0, void 0, function () {
            var refund;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.refunds.cancel(refundId)];
                    case 1:
                        refund = _a.sent();
                        return [2 /*return*/, refund];
                }
            });
        });
    };
    ;
    StripeService.prototype.createPayout = function (payoutParams, options) {
        return __awaiter(this, void 0, void 0, function () {
            var payout;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.payouts.create(payoutParams, options)];
                    case 1:
                        payout = _a.sent();
                        return [2 /*return*/, payout];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrievePayout = function (payoutId) {
        return __awaiter(this, void 0, void 0, function () {
            var payout;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.payouts.retrieve(payoutId)];
                    case 1:
                        payout = _a.sent();
                        return [2 /*return*/, payout];
                }
            });
        });
    };
    ;
    StripeService.prototype.updatePayout = function (payoutId, payoutParams, options) {
        return __awaiter(this, void 0, void 0, function () {
            var payout;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.payouts.update(payoutId, payoutParams, options)];
                    case 1:
                        payout = _a.sent();
                        return [2 /*return*/, payout];
                }
            });
        });
    };
    ;
    StripeService.prototype.cancelPayout = function (payoutId) {
        return __awaiter(this, void 0, void 0, function () {
            var payout;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.payouts.cancel(payoutId)];
                    case 1:
                        payout = _a.sent();
                        return [2 /*return*/, payout];
                }
            });
        });
    };
    ;
    StripeService.prototype.createSetupIntent = function (setupIntentParams) {
        return __awaiter(this, void 0, void 0, function () {
            var setupIntent;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.setupIntents.create(setupIntentParams)];
                    case 1:
                        setupIntent = _a.sent();
                        return [2 /*return*/, setupIntent];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrieveSetupIntent = function (setupIntentId) {
        return __awaiter(this, void 0, void 0, function () {
            var setupIntent;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.setupIntents.retrieve(setupIntentId)];
                    case 1:
                        setupIntent = _a.sent();
                        return [2 /*return*/, setupIntent];
                }
            });
        });
    };
    ;
    StripeService.prototype.updateSetupIntent = function (setupIntentId, setupIntentParams) {
        return __awaiter(this, void 0, void 0, function () {
            var setupIntent;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.setupIntents.update(setupIntentId, setupIntentParams)];
                    case 1:
                        setupIntent = _a.sent();
                        return [2 /*return*/, setupIntent];
                }
            });
        });
    };
    ;
    StripeService.prototype.confirmSetupIntent = function (setupIntentId, setupIntentParams) {
        return __awaiter(this, void 0, void 0, function () {
            var setupIntent;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.setupIntents.confirm(setupIntentId, setupIntentParams)];
                    case 1:
                        setupIntent = _a.sent();
                        return [2 /*return*/, setupIntent];
                }
            });
        });
    };
    ;
    StripeService.prototype.cancelSetupIntent = function (setupIntentId) {
        return __awaiter(this, void 0, void 0, function () {
            var setupIntent;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.setupIntents.cancel(setupIntentId)];
                    case 1:
                        setupIntent = _a.sent();
                        return [2 /*return*/, setupIntent];
                }
            });
        });
    };
    ;
    StripeService.prototype.listAllSetupIntents = function (customerId, paymentMethod, limit, startingAfter, endingBefore) {
        return __awaiter(this, void 0, void 0, function () {
            var setupIntent;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.setupIntents.list({
                            customer: customerId,
                            payment_method: paymentMethod,
                            limit: limit,
                            starting_after: startingAfter,
                            ending_before: endingBefore
                        })];
                    case 1:
                        setupIntent = _a.sent();
                        return [2 /*return*/, setupIntent];
                }
            });
        });
    };
    ;
    //* amounts: [35, 45] in cents or paise.
    StripeService.prototype.verifySetupIntent = function (setupIntentId, amounts) {
        return __awaiter(this, void 0, void 0, function () {
            var resource, VerifySetupIntentpromise;
            var _this = this;
            return __generator(this, function (_a) {
                resource = stripe_1.default.StripeResource.extend({
                    request: stripe_1.default.StripeResource.method({
                        method: 'POST',
                        path: "payment_intents/".concat(setupIntentId, "/verify_microdeposits"),
                    })
                });
                VerifySetupIntentpromise = new Promise(function (resolve, reject) {
                    new resource(_this._stripe).request({ amounts: amounts }, function (err, response) {
                        if (err)
                            reject(err);
                        resolve(response);
                    });
                });
                return [2 /*return*/, VerifySetupIntentpromise];
            });
        });
    };
    ;
    StripeService.prototype.createBankAccount = function (customerId, bankAccountParams) {
        return __awaiter(this, void 0, void 0, function () {
            var bankAccount;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.createSource(customerId, bankAccountParams)];
                    case 1:
                        bankAccount = _a.sent();
                        return [2 /*return*/, bankAccount];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrieveBankAccount = function (customerId, bankAccountId) {
        return __awaiter(this, void 0, void 0, function () {
            var bankAccount;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.retrieveSource(customerId, bankAccountId)];
                    case 1:
                        bankAccount = _a.sent();
                        return [2 /*return*/, bankAccount];
                }
            });
        });
    };
    ;
    StripeService.prototype.updateBankAccount = function (customerId, bankAccountId, bankAccountParams) {
        return __awaiter(this, void 0, void 0, function () {
            var bankAccount;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.updateSource(customerId, bankAccountId, bankAccountParams)];
                    case 1:
                        bankAccount = _a.sent();
                        return [2 /*return*/, bankAccount];
                }
            });
        });
    };
    ;
    //* example:  amounts: [32, 45]
    StripeService.prototype.verifyBankAccount = function (customerId, bankAccountId, amounts) {
        return __awaiter(this, void 0, void 0, function () {
            var bankAccount;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.verifySource(customerId, bankAccountId, { amounts: amounts })];
                    case 1:
                        bankAccount = _a.sent();
                        return [2 /*return*/, bankAccount];
                }
            });
        });
    };
    ;
    StripeService.prototype.deleteBankAccount = function (customerId, bankAccountId) {
        return __awaiter(this, void 0, void 0, function () {
            var bankAccount;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.deleteSource(customerId, bankAccountId)];
                    case 1:
                        bankAccount = _a.sent();
                        return [2 /*return*/, bankAccount];
                }
            });
        });
    };
    ;
    StripeService.prototype.listAllBankAccounts = function (customerId, limit, startingAfter, endingBefore) {
        return __awaiter(this, void 0, void 0, function () {
            var bankAccounts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.listSources(customerId, {
                            object: 'bank_account',
                            limit: limit,
                            starting_after: startingAfter,
                            ending_before: endingBefore
                        })];
                    case 1:
                        bankAccounts = _a.sent();
                        return [2 /*return*/, bankAccounts];
                }
            });
        });
    };
    ;
    // async createPaymentMethod(paymentMethodParams?: Stripe.PaymentMethodCreateParams): Promise<Stripe.Response<Stripe.PaymentMethod>> {
    //     const paymentMethod = await this._stripe.paymentMethods.create(paymentMethodParams);
    //     return paymentMethod;
    // };
    // async retrievePaymentMethod(paymentMethodId: string): Promise<Stripe.Response<Stripe.PaymentMethod>> {
    //     const paymentMethod = await this._stripe.paymentMethods.retrieve(paymentMethodId);
    //     return paymentMethod;
    // };
    // async updatePaymentMethod(paymentMethodId: string, paymentMethodParams?: Stripe.PaymentMethodUpdateParams): Promise<Stripe.Response<Stripe.PaymentMethod>> {
    //     const paymentMethod = await this._stripe.paymentMethods.update(
    //         paymentMethodId,
    //         paymentMethodParams
    //       );
    //     return paymentMethod;
    // };
    StripeService.prototype.listPaymentMethods = function (customerId, type, limit, startingAfter, endingBefore) {
        return __awaiter(this, void 0, void 0, function () {
            var paymentMethods;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.paymentMethods.list({
                            customer: customerId,
                            type: type,
                            limit: limit,
                            starting_after: startingAfter,
                            ending_before: endingBefore
                        })];
                    case 1:
                        paymentMethods = _a.sent();
                        return [2 /*return*/, paymentMethods];
                }
            });
        });
    };
    ;
    StripeService.prototype.listCustomerPaymentMethods = function (customerId, type, limit, startingAfter, endingBefore) {
        return __awaiter(this, void 0, void 0, function () {
            var paymentMethod;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.customers.listPaymentMethods(customerId, {
                            type: type,
                            limit: limit,
                            starting_after: startingAfter,
                            ending_before: endingBefore
                        })];
                    case 1:
                        paymentMethod = _a.sent();
                        return [2 /*return*/, paymentMethod];
                }
            });
        });
    };
    ;
    StripeService.prototype.createCheckoutSession = function (sessionParams) {
        return __awaiter(this, void 0, void 0, function () {
            var session;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.checkout.sessions.create(sessionParams)];
                    case 1:
                        session = _a.sent();
                        return [2 /*return*/, session];
                }
            });
        });
    };
    ;
    StripeService.prototype.expireCheckoutSession = function (sessionId, sessionParams) {
        return __awaiter(this, void 0, void 0, function () {
            var session;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.checkout.sessions.expire(sessionId, sessionParams)];
                    case 1:
                        session = _a.sent();
                        return [2 /*return*/, session];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrieveCheckoutSession = function (sessionId, sessionParams) {
        return __awaiter(this, void 0, void 0, function () {
            var session;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.checkout.sessions.retrieve(sessionId, sessionParams)];
                    case 1:
                        session = _a.sent();
                        return [2 /*return*/, session];
                }
            });
        });
    };
    ;
    StripeService.prototype.listAllCheckoutSessions = function (limit, startingAfter, endingBefore, expand) {
        return __awaiter(this, void 0, void 0, function () {
            var sessions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.checkout.sessions.list({
                            limit: limit,
                            starting_after: startingAfter,
                            ending_before: endingBefore,
                            expand: expand
                        })];
                    case 1:
                        sessions = _a.sent();
                        return [2 /*return*/, sessions];
                }
            });
        });
    };
    ;
    //! Do we need to provide "product_data.statement_descriptor", ask richard and jos anna.
    StripeService.prototype.createPrice = function (priceParams) {
        return __awaiter(this, void 0, void 0, function () {
            var price;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.prices.create(priceParams)];
                    case 1:
                        price = _a.sent();
                        return [2 /*return*/, price];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrievePrice = function (priceId) {
        return __awaiter(this, void 0, void 0, function () {
            var price;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.prices.retrieve(priceId)];
                    case 1:
                        price = _a.sent();
                        return [2 /*return*/, price];
                }
            });
        });
    };
    ;
    StripeService.prototype.updatePrice = function (priceId, priceParams) {
        return __awaiter(this, void 0, void 0, function () {
            var price;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.prices.update(priceId, priceParams)];
                    case 1:
                        price = _a.sent();
                        return [2 /*return*/, price];
                }
            });
        });
    };
    ;
    StripeService.prototype.searchPrice = function (query, limit, expand) {
        return __awaiter(this, void 0, void 0, function () {
            var prices;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.prices.search({ query: query, expand: expand, limit: limit })];
                    case 1:
                        prices = _a.sent();
                        return [2 /*return*/, prices];
                }
            });
        });
    };
    ;
    StripeService.prototype.listAllPrices = function (active, type, currency, product, recurring, limit, startingAfter, endingBefore, expand) {
        return __awaiter(this, void 0, void 0, function () {
            var prices;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.prices.list({
                            active: active,
                            type: type,
                            currency: currency,
                            product: product,
                            recurring: recurring,
                            limit: limit,
                            starting_after: startingAfter,
                            ending_before: endingBefore,
                            expand: expand,
                        })];
                    case 1:
                        prices = _a.sent();
                        return [2 /*return*/, prices];
                }
            });
        });
    };
    ;
    StripeService.prototype.createProduct = function (productParams) {
        return __awaiter(this, void 0, void 0, function () {
            var product;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.products.create(productParams)];
                    case 1:
                        product = _a.sent();
                        return [2 /*return*/, product];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrieveProduct = function (productId) {
        return __awaiter(this, void 0, void 0, function () {
            var product;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.products.retrieve(productId)];
                    case 1:
                        product = _a.sent();
                        return [2 /*return*/, product];
                }
            });
        });
    };
    ;
    StripeService.prototype.updateProduct = function (productId, productParams) {
        return __awaiter(this, void 0, void 0, function () {
            var product;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.products.update(productId, productParams)];
                    case 1:
                        product = _a.sent();
                        return [2 /*return*/, product];
                }
            });
        });
    };
    ;
    StripeService.prototype.searchProducts = function (query, limit, expand) {
        return __awaiter(this, void 0, void 0, function () {
            var products;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.products.search({ query: query, expand: expand, limit: limit })];
                    case 1:
                        products = _a.sent();
                        return [2 /*return*/, products];
                }
            });
        });
    };
    ;
    StripeService.prototype.listAllProducts = function (active, type, ids, url, limit, startingAfter, endingBefore, expand) {
        return __awaiter(this, void 0, void 0, function () {
            var products;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.products.list({
                            active: active,
                            type: type,
                            ids: ids,
                            url: url,
                            limit: limit,
                            starting_after: startingAfter,
                            ending_before: endingBefore,
                            expand: expand
                        })];
                    case 1:
                        products = _a.sent();
                        return [2 /*return*/, products];
                }
            });
        });
    };
    ;
    StripeService.prototype.deleteProduct = function (productId) {
        return __awaiter(this, void 0, void 0, function () {
            var product;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.products.del(productId)];
                    case 1:
                        product = _a.sent();
                        return [2 /*return*/, product];
                }
            });
        });
    };
    ;
    StripeService.prototype.createBankAccountToken = function (bankAccountTokenParams) {
        return __awaiter(this, void 0, void 0, function () {
            var bankAccountToken;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.tokens.create(bankAccountTokenParams)];
                    case 1:
                        bankAccountToken = _a.sent();
                        return [2 /*return*/, bankAccountToken];
                }
            });
        });
    };
    ;
    StripeService.prototype.createAccount = function (accountParams) {
        return __awaiter(this, void 0, void 0, function () {
            var account;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.accounts.create(accountParams)];
                    case 1:
                        account = _a.sent();
                        return [2 /*return*/, account];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrieveAccount = function (accountId) {
        return __awaiter(this, void 0, void 0, function () {
            var account;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.accounts.retrieve(accountId)];
                    case 1:
                        account = _a.sent();
                        return [2 /*return*/, account];
                }
            });
        });
    };
    ;
    StripeService.prototype.updateAccount = function (accountId, accountParams) {
        return __awaiter(this, void 0, void 0, function () {
            var account;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.accounts.update(accountId, accountParams)];
                    case 1:
                        account = _a.sent();
                        return [2 /*return*/, account];
                }
            });
        });
    };
    ;
    StripeService.prototype.rejectAccount = function (accountId, accountRejectedParams) {
        return __awaiter(this, void 0, void 0, function () {
            var account;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.accounts.reject(accountId, accountRejectedParams)];
                    case 1:
                        account = _a.sent();
                        return [2 /*return*/, account];
                }
            });
        });
    };
    ;
    StripeService.prototype.deleteAccount = function (accountId, accountDeleteParams) {
        return __awaiter(this, void 0, void 0, function () {
            var account;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.accounts.del(accountId, accountDeleteParams)];
                    case 1:
                        account = _a.sent();
                        return [2 /*return*/, account];
                }
            });
        });
    };
    ;
    StripeService.prototype.createAccountLink = function (accountLinkParams) {
        return __awaiter(this, void 0, void 0, function () {
            var accountLink;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.accountLinks.create(accountLinkParams)];
                    case 1:
                        accountLink = _a.sent();
                        return [2 /*return*/, accountLink];
                }
            });
        });
    };
    ;
    StripeService.prototype.createTransfer = function (transferParams) {
        return __awaiter(this, void 0, void 0, function () {
            var transfer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.transfers.create(transferParams)];
                    case 1:
                        transfer = _a.sent();
                        return [2 /*return*/, transfer];
                }
            });
        });
    };
    ;
    StripeService.prototype.retrieveTransfer = function (transferId) {
        return __awaiter(this, void 0, void 0, function () {
            var transfer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.transfers.retrieve(transferId)];
                    case 1:
                        transfer = _a.sent();
                        return [2 /*return*/, transfer];
                }
            });
        });
    };
    ;
    StripeService.prototype.updateTransfer = function (transferId, transferParams) {
        return __awaiter(this, void 0, void 0, function () {
            var transfer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._stripe.transfers.update(transferId, transferParams)];
                    case 1:
                        transfer = _a.sent();
                        return [2 /*return*/, transfer];
                }
            });
        });
    };
    ;
    return StripeService;
}());
exports.StripeService = StripeService;
;
