"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a, _b, _c;
Object.defineProperty(exports, "__esModule", { value: true });
exports.effectivePaginator = exports.paginator = void 0;
var interfaces_1 = require("../interfaces");
var joi_1 = __importDefault(require("joi"));
var paginatorTypePossibilities = Object.values(interfaces_1.PaginatorTypes);
var sortTypePossibilities = Object.values(interfaces_1.SortTypes);
var effectivePaginator = joi_1.default.object()
    .keys({
    type: (_a = joi_1.default.string().label("Paginator Type")).valid.apply(_a, paginatorTypePossibilities).optional().default(interfaces_1.PaginatorTypes.FORWARD),
    startIndex: joi_1.default.optional().label("Paginator Start Index"),
    endIndex: joi_1.default.optional().label("Paginator End Index"),
    size: joi_1.default.number().optional().default(0).label("Paginator Size"),
    sortField: joi_1.default.string().optional().default('_id').label("Paginator Sort Field"),
    sortFieldValue: joi_1.default.string().optional().label("Paginator Sort Field Value"),
    // Joi.string().when('startIndex', {
    //     is: Joi.exist(),
    //     then: Joi.string()
    //         .required()
    //         .label("Paginator Sort Field Value")
    //         .messages({
    //             'any.required': 'Paginator Sort Field Value is a required field, you can pick this value from the same document where you have picked the start index value.'
    //         }),
    //     otherwise: Joi.string().when('endIndex', {
    //         is: Joi.exist(),
    //         then: Joi.string()
    //             .required()
    //             .label("Paginator Sort Field Value")
    //             .messages({
    //                 'any.required': 'Paginator Sort Field Value is a required field, you can pick this value from the same document where you have picked the end index value.'
    //             }),
    //         otherwise: Joi.optional(),
    //     }),
    // }),
    sortType: (_b = joi_1.default.string()).valid.apply(_b, sortTypePossibilities).optional().default(interfaces_1.SortTypes.ASC).label("Paginator Sort Type"),
})
    .required();
exports.effectivePaginator = effectivePaginator;
var paginator = joi_1.default.object()
    .keys({
    size: joi_1.default.number().default(0).optional().label("Paginator Size"),
    sortField: joi_1.default.string().label("Paginator Sort Field").default('_id').optional(),
    sortType: (_c = joi_1.default.string().default(interfaces_1.SortTypes.ASC).label("Paginator Sort Type")).valid.apply(_c, sortTypePossibilities).optional(),
    pageIndex: joi_1.default.number().label("Paginator Page Index").default(0).min(0).optional(),
})
    .required();
exports.paginator = paginator;
